'===================================================================
' Apci59s.vb
'-------------------------------------------------------------------
' aPCI-M59
' Copyright (C) ADTEK SYSTEM SCIENCE Co.,Ltd.
'
' ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
'===================================================================

Option Strict Off
Option Explicit On 

Imports System.Runtime.InteropServices

Public Class Form1
    Inherits System.Windows.Forms.Form

    Dim M59w As Apci59w

#Region " Windows tH[ fUCiŐꂽR[h "

    Public Sub New()
        MyBase.New()

        ' ̌Ăяo Windows tH[ fUCiŕKvłB
        InitializeComponent()

        ' InitializeComponent() Ăяǒɏǉ܂B

    End Sub

    ' Form ́AR|[lgꗗɌ㏈s邽߂ dispose I[o[Ch܂B
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows tH[ fUCiŕKvłB
    Private components As System.ComponentModel.IContainer

    '  : ȉ̃vV[ẂAWindows tH[ fUCiŕKvłB
    'Windows tH[ fUCigĕύXĂB  
    ' R[h GfB^gĕύXȂłB
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.ClientSize = New System.Drawing.Size(292, 266)
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "aPCI-M59 Sample"

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim strbuf As String
        Dim dwDllVer As Long, dwDrvVer As Integer
        Dim wLogSlot As Short
        Dim wAxis As Short
        Dim ri As Apci59w.Resource
        Dim b As Byte
        Dim dwCount As Integer
        Dim dwSWVal As Integer
        Dim i As Integer

        ' 
        M59w = New Apci59w
        ri = New Apci59w.Resource
        ri.dwMemBase = New Integer(Apci59w.MAX_MEM) {}
        ri.dwMemLength = New Integer(Apci59w.MAX_MEM) {}
        ri.dwMemAttrib = New Integer(Apci59w.MAX_MEM) {}
        ri.dwIOPortBase = New Integer(Apci59w.MAX_IO) {}
        ri.dwIOPortLength = New Integer(Apci59w.MAX_IO) {}
        ri.dwIRQRegisters = New Integer(Apci59w.MAX_IRQ) {}
        ri.dwIRQAttrib = New Integer(Apci59w.MAX_IRQ) {}
        ri.dwDMALst = New Integer(Apci59w.MAX_DMA) {}
        ri.dwDMAAttrib = New Integer(Apci59w.MAX_DMA) {}
        ri.dwReserved1 = New Integer(Apci59w.MAX_RSV) {}

        ' 
        ri.dwNumMemWindows = 0
        For i = 0 To Apci59w.MAX_MEM
            ri.dwMemBase(i) = 0
            ri.dwMemLength(i) = 0
            ri.dwMemAttrib(i) = 0
        Next
        ri.dwNumIOPorts = 0
        For i = 0 To Apci59w.MAX_IO
            ri.dwIOPortBase(i) = 0
            ri.dwIOPortLength(i) = 0
        Next
        ri.dwNumIRQs = 0
        For i = 0 To Apci59w.MAX_IRQ
            ri.dwIRQRegisters(i) = 0
            ri.dwIRQAttrib(i) = 0
        Next
        ri.dwNumDMAs = 0
        For i = 0 To Apci59w.MAX_DMA
            ri.dwDMALst(i) = 0
            ri.dwDMAAttrib(i) = 0
        Next
        For i = 0 To Apci59w.MAX_RSV
            ri.dwReserved1(i) = 0
        Next

        '---------------------------------------------------------------
        ' o[W\
        '---------------------------------------------------------------
        If False = M59w.GetVersion(dwDllVer, dwDrvVer) Then
            ErrorMessage(Apci59w.SLOT_AUTO)
            Exit Sub
        End If
        strbuf = String.Concat("GetVersion", vbCrLf, _
                                String.Format("DLL Version: &H{0:X8}", dwDllVer), vbCrLf, _
                                String.Format("DRV Version: &H{0:X8}", dwDrvVer))
        ResultMessage(strbuf)
        '---------------------------------------------------------------
        ' foCX̎gp錾
        '---------------------------------------------------------------
        wLogSlot = Apci59w.SLOT_AUTO     '󂫃foCXw
        If False = M59w.Create(wLogSlot) Then
            ErrorMessage(Apci59w.SLOT_AUTO)
            Exit Sub
        End If
        strbuf = String.Concat("Created", vbCrLf, vbCrLf, _
                                String.Format("LogSlot: {0:d}", wLogSlot))
        ResultMessage(strbuf)
        '---------------------------------------------------------------
        ' \[X\
        '---------------------------------------------------------------
        If False = M59w.GetResource(wLogSlot, ri) Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Concat("Resource", vbCrLf, _
                                String.Format("IO Base Address: &H{0:x4} -&H{1:x4}", _
                                                ri.dwIOPortBase(0), _
                                                ri.dwIOPortBase(0) + ri.dwIOPortLength(0) - 1))
        ResultMessage(strbuf)
        '---------------------------------------------------------------
        ' armXCb`̒l\
        '---------------------------------------------------------------
        If False = M59w.GetSwitchValue(wLogSlot, dwSWVal) Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Format("BSN: &H{0:x}", dwSWVal)
        ResultMessage(strbuf)
        '---------------------------------------------------------------
        ' Pw
        '---------------------------------------------------------------
        wAxis = Apci59w.AXIS_1
        '---------------------------------------------------------------
        ' 䎲
        '---------------------------------------------------------------
        If False = InitAxis(wLogSlot, wAxis) Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Concat("䎲܂")
        ResultMessage(strbuf)
        '---------------------------------------------------------------
        ' { 10000pXo
        '---------------------------------------------------------------
        If False = M59w.DataFullWrite(wLogSlot, wAxis, _
                                        Apci59w.PLUS_PRESET_PULSE_DRIVE, 10000) Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Concat("{ 10000pXo͂Ă܂")
        ResultMessage(strbuf)
        '---------------------------------------------------------------
        ' hCuXe[^X擾
        '---------------------------------------------------------------
        If False = M59w.GetDriveStatus(wLogSlot, wAxis, b) Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        '---------------------------------------------------------------
        ' rW[tOĂihCuȂj~
        '---------------------------------------------------------------
        If (b And &H1) = &H1 Then
            If False = M59w.CommandWrite(wLogSlot, wAxis, _
                                            Apci59w.SLOW_DOWN_STOP) Then
                ErrorMessage(wLogSlot)
                Exit Sub
            End If
            strbuf = String.Concat("~܂")
            ResultMessage(strbuf)
        End If
        '---------------------------------------------------------------
        ' GhXe[^X擾
        '---------------------------------------------------------------
        If False = M59w.GetEndStatus(wLogSlot, wAxis, b) Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Format("GhXe[^X &H{0:x}", b)
        ResultMessage(strbuf)
        '---------------------------------------------------------------
        ' JE^[\
        '---------------------------------------------------------------
        dwCount = 0
        If False = M59w.DataFullRead(wLogSlot, wAxis, _
                                        Apci59w.INTERNAL_COUNTER_READ, dwCount) Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        '---------------------------------------------------------------
        ' g
        '---------------------------------------------------------------
        If dwCount And &H8000000 Then
            dwCount = dwCount Or &HF0000000
        End If

        strbuf = String.Format("JE^ {0}", dwCount)
        ResultMessage(strbuf)
        '---------------------------------------------------------------
        ' JjJVOi\
        '---------------------------------------------------------------
        If False = M59w.GetMechanicalSignal(wLogSlot, wAxis, b) Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Format("JjJVOi &H{0:x}", b)
        ResultMessage(strbuf)
        '---------------------------------------------------------------
        ' jo[TVOi\
        '---------------------------------------------------------------
        If False = M59w.GetUniversalSignal(wLogSlot, wAxis, b) Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Format("jo[TVOi &H{0:x}", b)
        ResultMessage(strbuf)
        '---------------------------------------------------------------
        ' foCX
        '---------------------------------------------------------------
        If False = M59w.Close(wLogSlot) Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        ResultMessage("Closed")
        Me.Close()
    End Sub

    '===================================================================
    ' 䎲̏
    '-------------------------------------------------------------------
    '           wLogSlot    foCXԍ
    '               wAxis       䎲
    '                           APCI59_AXIS_1 ` APCI59_AXIS_4 w肵܂
    '===================================================================
    Function InitAxis(ByVal wLogSlot As Integer, ByVal wAxis As Integer) As Integer

        InitAxis = False
        '---------------------------------------------------------------
        ' MODE1 SET
        '
        ' Jn|Cgo              
        ' pXo͕                        QpX
        ' DIR   o͒[q                        CWpX  ANeBu Hi
        ' PULSE o͒[q                        CCWpX ANeBu Hi
        '---------------------------------------------------------------
        If False = M59w.Mode1Write(wLogSlot, wAxis, &H40) Then Exit Function
        '---------------------------------------------------------------
        ' MODE2 SET
        '
        ' EXTERNAL COUNTER ͎dl             QMS{
        ' DEND ͐MANeBux         Low
        ' DERR ͐MANeBux         Low
        ' -SLM ͐MANeBux         Low
        ' +SLM ͐MANeBux         Low
        ' -ELM ͐MANeBux         Low
        ' +ELM ͐MANeBux         Low
        '---------------------------------------------------------------
        If False = M59w.Mode2Write(wLogSlot, wAxis, &HFF) Then Exit Function
        '---------------------------------------------------------------
        ' [hݒ
        '
        ' INPOSITION WAIT MODE RESET
        ' ALARM STOP ENABLE MODE SET
        ' INTERRUPT OUT ENABLE MODE RESET
        '---------------------------------------------------------------
        If False = M59w.CommandWrite(wLogSlot, wAxis, Apci59w.INPOSITION_WAIT_MODE_RESET) Then Exit Function
        If False = M59w.CommandWrite(wLogSlot, wAxis, Apci59w.ALARM_STOP_ENABLE_MODE_SET) Then Exit Function
        If False = M59w.CommandWrite(wLogSlot, wAxis, Apci59w.INTERRUPT_OUT_ENABLE_MODE_RESET) Then Exit Function
        '---------------------------------------------------------------
        ' f[^ݒ
        '
        ' RANGE DATA                 50  o͎gݒP  50050=10PPS
        ' START/STOP SPEED DATA     100  Jn~g      100~10PPS=1000PPS
        ' OBJECT SPEED DATA        4000  ړIg          4000~10PPS=40000PPS
        ' RATE-1 DATA              1024  ԐݒP    1024(2.048~10^6)=0.5mSec
        '                                            (4000-100)~0.5mSec = 1.95Sec
        ' RATE-2 DATA                    ftHgl 8191(1FFFh)
        ' RATE-3 DATA                    ftHgl 8191(1FFFh)
        ' RATE CHANGE POINT 1-2          ftHgl 8191(1FFFh)
        ' RATE CHANGE POINT 2-3          ftHgl 8191(1FFFh)
        '
        ' ̐ݒɂ RATE-1 DATA ɂ钼ƂȂ܂
        '---------------------------------------------------------------
        If False = M59w.DataHalfWrite(wLogSlot, wAxis, Apci59w.RANGE_DATA_WRITE, 50) Then Exit Function
        If False = M59w.DataHalfWrite(wLogSlot, wAxis, Apci59w.START_STOP_SPEED_DATA_WRITE, 100) Then Exit Function
        If False = M59w.DataFullWrite(wLogSlot, wAxis, Apci59w.OBJECT_SPEED_DATA_WRITE, 4000) Then Exit Function
        If False = M59w.DataFullWrite(wLogSlot, wAxis, Apci59w.RATE1_DATA_WRITE, 1024) Then Exit Function
        '---------------------------------------------------------------
        ' AhXݒ
        '
        ' INTERNAL COUNTER y EXTERNAL COUNTER  0h ݂܂
        '---------------------------------------------------------------
        If False = M59w.DataFullWrite(wLogSlot, wAxis, Apci59w.INTERNAL_COUNTER_WRITE, 0) Then Exit Function
        If False = M59w.DataFullWrite(wLogSlot, wAxis, Apci59w.EXTERNAL_COUNTER_WRITE, 0) Then Exit Function

        InitAxis = True

    End Function

    '============================================================================
    '    ʂ\
    '============================================================================
    Private Sub ResultMessage(ByVal lpszbuf As String)
        MsgBox(lpszbuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Information, Me.Text)
    End Sub

    '============================================================================
    '    G[bZ[W\
    '============================================================================
    Private Sub ErrorMessage(ByVal wLogSlot As Short)
        Dim dwRes As Integer
        Dim szBuf As String

        dwRes = M59w.GetLastError(wLogSlot)
        Select Case dwRes
            Case Apci59w.ERR_WRAPDLL, Apci59w.ERR_SYSTEM
                dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error()
                szBuf = String.Concat("System error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: &H{0:X8}", dwRes))
            Case Else
                szBuf = String.Concat("aPCI-M59 error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: &H{0:X8}", dwRes))
        End Select
        MsgBox(szBuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, Me.Text)
    End Sub

End Class
