Attribute VB_Name = "Wrapper"
'===================================================================
' Apci59w.bas
'
' aPCI-M59
'
' Copyright (C) ADTEK SYSTEM SCIENCE Co.,Ltd.
'===================================================================
Option Explicit                                         'SĂ̕ϐ𖾎Iɐ錾

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI59_DLL_NAME = "Apci59.dll"             ' DLL
Dim hDLL As Long                                        ' DLLւ̃nh
Global Const APCI59_ERR_WRAPDLL = -1                    ' bp[֐G[

'===================================================================
'       Apci59.dll [h
'       
' ߂l  True
'        s False
'===================================================================
Function Apci59wDllOpen() As Boolean
    Apci59wDllOpen = False
    If hDLL <> 0 Then Exit Function
    hDLL = LoadLibrary(APCI59_DLL_NAME)
    If hDLL = 0 Then Exit Function
    If Apci59wGetDllExportFunc() = False Then
        Apci59wDllClose         ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If
    Apci59wDllOpen = True
End Function
'===================================================================
'       Apci59.dllA[h
'       
' ߂l  True
'        s False
'===================================================================
Function Apci59wDllClose() As Boolean
    Apci59wDllClose = True
    If hDLL = 0 Then Exit Function
    If FreeLibrary(hDLL) <> 0 Then
        hDLL = 0
    Else
        Apci59wDllClose = False
    End If
End Function
'===================================================================
'    o[Wԍ擾
'    pdwDllVer  DLLo[Wԍi[
'        pdwDrvVer  DRVo[Wԍi[
' ߂l  True
'        s False
'===================================================================
Function Apci59wGetVersion(ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Boolean
    Apci59wGetVersion = False
    If hDLL = 0 Then Exit Function
    If Apci59GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function
    Apci59wGetVersion = True
End Function
'===================================================================
'    foCX̎gp錾
'    pwLogSlot gpfoCXi[
' ߂l  True
'        s False
'===================================================================
Function Apci59wCreate(ByRef pwLogSlot As Integer) As Boolean
    Apci59wCreate = False
    If hDLL = 0 Then Exit Function
    If Apci59Create(pwLogSlot) = 0 Then Exit Function
    Apci59wCreate = True
End Function
'===================================================================
'    foCX̊J
'    wLogSlot   gpfoCX
' ߂l  True
'        s False
'===================================================================
Function Apci59wClose(ByVal wLogSlot As Integer) As Long
    Apci59wClose = False
    If hDLL = 0 Then Exit Function
    If Apci59Close(wLogSlot) = 0 Then Exit Function
    Apci59wClose = True
End Function
'===================================================================
'    wfoCX̃\[X擾
'    wLogSlot   foCX
'        pres       \[Xi[\
' ߂l  True
'        s False
'===================================================================
Function Apci59wGetResource(ByVal wLogSlot As Integer, ByRef pres As APCI59RESOURCE) As Boolean
    Apci59wGetResource = False
    If hDLL = 0 Then Exit Function
    If Apci59GetResource(wLogSlot, pres) = 0 Then Exit Function
    Apci59wGetResource = True
End Function
'===================================================================
'    wfoCXɑ΂ǂݍݎs
'    wLogSlot       foCX
'        wAxis          Ώې䎲
'        wPort          |[gԍiO`Vj
'        pbData         ̓f[^i[
' ߂l  True
'        s False
'===================================================================
Function Apci59wInPort(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByVal wPort As Integer, ByRef pbData As Byte) As Boolean
    Apci59wInPort = False
    If hDLL = 0 Then Exit Function
    If Apci59InPort(wLogSlot, wAxis, wPort, pbData) = 0 Then Exit Function
    Apci59wInPort = True
End Function
'===================================================================
'    wfoCXɑ΂ݎs
'    wLogSlot       foCX
'        wAxis          Ώې䎲
'        wPort          |[gԍiO`Vj
'        bData          o̓f[^
' ߂l  True
'        s False
'===================================================================
Function Apci59wOutPort(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByVal wPort As Integer, ByVal bData As Byte) As Boolean
    Apci59wOutPort = False
    If hDLL = 0 Then Exit Function
    If Apci59OutPort(wLogSlot, wAxis, wPort, bData) = 0 Then Exit Function
    Apci59wOutPort = True
End Function
'===================================================================
'    G[R[h擾
'    wLogSlot       foCX
' ߂l  True
'        s False
'===================================================================
Function Apci59wGetLastError(ByVal wLogSlot As Integer) As Long
    Apci59wGetLastError = APCI59_ERR_WRAPDLL
    If hDLL = 0 Then Exit Function
    Apci59wGetLastError = Apci59GetLastError(wLogSlot)
End Function
'===================================================================
'    hCuXe[^X擾
'    wLogSlot   foCX
'        wAxis      Ώې䎲
'        pbStatus   Xe[^Xi[
' ߂l  True
'        s False
'===================================================================
Function Apci59wGetDriveStatus(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByRef pbStatus As Byte) As Boolean
    Apci59wGetDriveStatus = False
    If hDLL = 0 Then Exit Function
    If Apci59GetDriveStatus(wLogSlot, wAxis, pbStatus) = 0 Then Exit Function
    Apci59wGetDriveStatus = True
End Function
'===================================================================
'    GhXe[^X擾
'    wLogSlot   foCX
'        wAxis      Ώې䎲
'        pbStatus   Xe[^Xi[
' ߂l  True
'        s False
'===================================================================
Function Apci59wGetEndStatus(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByRef pbStatus As Byte) As Boolean
    Apci59wGetEndStatus = False
    If hDLL = 0 Then Exit Function
    If Apci59GetEndStatus(wLogSlot, wAxis, pbStatus) = 0 Then Exit Function
    Apci59wGetEndStatus = True
End Function
'===================================================================
'    JjJVOi擾
'    wLogSlot   foCX
'        wAxis      Ώې䎲
'        pbSignal   VOii[
' ߂l  True
'        s False
'===================================================================
Function Apci59wGetMechanicalSignal(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByRef pbSignal As Byte) As Boolean
    Apci59wGetMechanicalSignal = False
    If hDLL = 0 Then Exit Function
    If Apci59GetMechanicalSignal(wLogSlot, wAxis, pbSignal) = 0 Then Exit Function
    Apci59wGetMechanicalSignal = True
End Function
'===================================================================
'    jo[TVOi擾
'    wLogSlot   foCX
'        wAxis      Ώې䎲
'        pbSignal   VOii[
' ߂l  True
'        s False
'===================================================================
Function Apci59wGetUniversalSignal(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByRef pbSignal As Byte) As Boolean
    Apci59wGetUniversalSignal = False
    If hDLL = 0 Then Exit Function
    If Apci59GetUniversalSignal(wLogSlot, wAxis, pbSignal) = 0 Then Exit Function
    Apci59wGetUniversalSignal = True
End Function
'===================================================================
'    [hP
'    wLogSlot   foCX
'        wAxis      Ώې䎲
'        bMode      [hl
' ߂l  True
'        s False
'===================================================================
Function Apci59wMode1Write(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByVal bMode As Byte) As Boolean
    Apci59wMode1Write = False
    If hDLL = 0 Then Exit Function
    If Apci59Mode1Write(wLogSlot, wAxis, bMode) = 0 Then Exit Function
    Apci59wMode1Write = True
End Function
'===================================================================
'    [hQ
'    wLogSlot   foCX
'        wAxis      Ώې䎲
'        bMode      [hl
' ߂l  True
'        s False
'===================================================================
Function Apci59wMode2Write(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByVal bMode As Byte) As Boolean
    Apci59wMode2Write = False
    If hDLL = 0 Then Exit Function
    If Apci59Mode2Write(wLogSlot, wAxis, bMode) = 0 Then Exit Function
    Apci59wMode2Write = True
End Function
'===================================================================
'    jo[TVOi
'    wLogSlot   foCX
'        wAxis      Ώې䎲
'        bSignal    VOil
' ߂l  True
'        s False
'===================================================================
Function Apci59wUniversalSignalWrite(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByVal bSignal As Byte) As Boolean
    Apci59wUniversalSignalWrite = False
    If hDLL = 0 Then Exit Function
    If Apci59UniversalSignalWrite(wLogSlot, wAxis, bSignal) = 0 Then Exit Function
    Apci59wUniversalSignalWrite = True
End Function
'===================================================================
'    QoCgf[^ǂݍ
'    wLogSlot   foCX
'        wAxis      Ώې䎲
'        bCmd       R}h
'        pwData     f[^i[
' ߂l  True
'        s False
'===================================================================
Function Apci59wDataHalfRead(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByVal bCmd As Byte, ByRef pwData As Integer) As Boolean
    Apci59wDataHalfRead = False
    If hDLL = 0 Then Exit Function
    If Apci59DataHalfRead(wLogSlot, wAxis, bCmd, pwData) = 0 Then Exit Function
    Apci59wDataHalfRead = True
End Function
'===================================================================
'    SoCgf[^ǂݍ
'    wLogSlot   foCX
'        wAxis      Ώې䎲
'        bCmd       R}h
'        pdwData    f[^i[
' ߂l  True
'        s False
'===================================================================
Function Apci59wDataFullRead(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByVal bCmd As Byte, ByRef pdwData As Long) As Boolean
    Apci59wDataFullRead = False
    If hDLL = 0 Then Exit Function
    If Apci59DataFullRead(wLogSlot, wAxis, bCmd, pdwData) = 0 Then Exit Function
    Apci59wDataFullRead = True
End Function
'===================================================================
'    R}h
'    wLogSlot   foCX
'        wAxis      Ώې䎲
'        bCmd       R}h
' ߂l  True
'        s False
'===================================================================
Function Apci59wCommandWrite(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByVal bCmd As Byte) As Boolean
    Apci59wCommandWrite = False
    If hDLL = 0 Then Exit Function
    If Apci59CommandWrite(wLogSlot, wAxis, bCmd) = 0 Then Exit Function
    Apci59wCommandWrite = True
End Function
'===================================================================
'    QoCgf[^
'    wLogSlot   foCX
'        wAxis      Ώې䎲
'        bCmd       R}h
'        wData     f[^
' ߂l  True
'        s False
'===================================================================
Function Apci59wDataHalfWrite(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByVal bCmd As Byte, ByVal pwData As Integer) As Boolean
    Apci59wDataHalfWrite = False
    If hDLL = 0 Then Exit Function
    If Apci59DataHalfWrite(wLogSlot, wAxis, bCmd, pwData) = 0 Then Exit Function
    Apci59wDataHalfWrite = True
End Function
'===================================================================
'    SoCgf[^
'    wLogSlot   foCX
'        wAxis      Ώې䎲
'        bCmd       R}h
'        dwData     f[^
' ߂l  True
'        s False
'===================================================================
Function Apci59wDataFullWrite(ByVal wLogSlot As Integer, ByVal wAxis As Integer, ByVal bCmd As Byte, ByVal pdwData As Long) As Boolean
    Apci59wDataFullWrite = False
    If hDLL = 0 Then Exit Function
    If Apci59DataFullWrite(wLogSlot, wAxis, bCmd, pdwData) = 0 Then Exit Function
    Apci59wDataFullWrite = True
End Function
'===================================================================
'    armXCb`̒l擾
'    wLogSlot       foCX
'        pdwSwitchValue XCb`̒li[̈ւ̃|C^
' ߂l  True
'        s False
'===================================================================
Function Apci59wGetSwitchValue(ByVal wLogSlot As Integer, ByRef pdwSwitchValue As Long) As Boolean
    Apci59wGetSwitchValue = False
    If hDLL = 0 Then Exit Function
    If Apci59GetSwitchValue(wLogSlot, pdwSwitchValue) = 0 Then Exit Function
    Apci59wGetSwitchValue = True
End Function
'-------------------------------------------------------------------
'    DLLGNX|[g֐AhX̎擾
'    
' ߂l  True
'        s False
'-------------------------------------------------------------------
Private Function Apci59wGetDllExportFunc() As Boolean
    Dim pFunc As Long

    Apci59wGetDllExportFunc = False

    pFunc = GetProcAddress(hDLL, "Apci59GetVersion")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59GetVersion")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59Create")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59Close")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59GetResource")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59InPort")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59OutPort")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59GetLastError")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59GetDriveStatus")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59GetEndStatus")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59GetMechanicalSignal")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59GetUniversalSignal")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59Mode1Write")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59Mode2Write")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59UniversalSignalWrite")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59DataHalfRead")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59DataFullRead")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59CommandWrite")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59DataHalfWrite")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59DataFullWrite")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci59GetSwitchValue")
    If pFunc = 0 Then Exit Function

    Apci59wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function

