//*******************************************************************
// Apci59w.pas
//
// aPCI-M59
//
// Copyright (C) ADTEK SYSTEM SCIENCE Co.,Ltd.
//
// Date Jul.1999
//*******************************************************************
unit Apci59w;

interface

uses
  Windows;

const
  // DLL Name
  APCI59_DLL_NAME												='Apci59.DLL';

  // Error code
  APCI59_SUCCESS												=0;		// ُȂiIj
  APCI59_ERR_SYSTEM											=1;		// VXeG[
  APCI59_ERR_NO_DEVICE									=2;		// gp\ȃfoCX܂
  APCI59_ERR_IN_USE											=3;		// w̃foCX͎gpł
  APCI59_ERR_INVALID_SLOT								=4;		// Ș_Xbgł
  APCI59_ERR_RESOURCE										=5;		// \[XG[
  APCI59_ERR_INVALID_PORT								=6;		// sȃ|[gv
  APCI59_ERR_INVALID_ARGUMENT						=7;		// sȈv܂
  APCI59_ERR_INVALID_AXIS								=50; 	// Ȑ䎲v

  // Axis
  APCI59_AXIS_1													=0;
  APCI59_AXIS_2													=1;
  APCI59_AXIS_3													=2;
  APCI59_AXIS_4													=3;

  // command
  APCI59_RANGE_DATA_WRITE                  = $00;
  APCI59_RANGE_DATA_READ                   = $01;
  APCI59_START_STOP_SPEED_DATA_WRITE       = $02;
  APCI59_START_STOP_SPEED_DATA_READ        = $03;
  APCI59_OBJECT_SPEED_DATA_WRITE           = $04;
  APCI59_OBJECT_SPEED_DATA_READ            = $05;
  APCI59_RATE1_DATA_WRITE	                 = $06;
  APCI59_RATE1_DATA_READ	                 = $07;
  APCI59_RATE2_DATA_WRITE	                 = $08;
  APCI59_RATE2_DATA_READ	                 = $09;
  APCI59_RATE3_DATA_WRITE	                 = $0a;
  APCI59_RATE3_DATA_READ	                 = $0b;
  APCI59_RATE_CHANGE_POINT_1_2_WRITE       = $0c;
  APCI59_RATE_CHANGE_POINT_1_2_READ        = $0d;
  APCI59_RATE_CHANGE_POINT_2_3_WRITE       = $0e;
  APCI59_RATE_CHANGE_POINT_2_3_READ        = $0f;
  APCI59_SLOW_DOWN_REAR_PULSE_WRITE        = $10;
  APCI59_SLOW_DOWN_REAR_PULSE_READ         = $11;
  APCI59_NOW_SPEED_DATA_READ	             = $12;
  APCI59_DRIVE_PULSE_COUNTER_READ          = $13;
  APCI59_PRESET_PULSE_DATA_OVERRIDE        = $14;
  APCI59_PRESET_PULSE_DATA_READ	           = $15;
  APCI59_DEVIATION_DATA_READ	             = $16;
  APCI59_INPOSITION_WAIT_MODE1_SET         = $17;
  APCI59_INPOSITION_WAIT_MODE2_SET         = $18;
  APCI59_INPOSITION_WAIT_MODE_RESET        = $19;
  APCI59_ALARM_STOP_ENABLE_MODE_SET        = $1a;
  APCI59_ALARM_STOP_ENABLE_MODE_RESET      = $1b;
  APCI59_INTERRUPT_OUT_ENABLE_MODE_SET	   = $1c;
  APCI59_INTERRUPT_OUT_ENABLE_MODE_RESET   = $1d;
  APCI59_SLOW_DOWN_STOP			               = $1e;
  APCI59_EMERGENCY_STOP			               = $1f;
  APCI59_PLUS_PRESET_PULSE_DRIVE	         = $20;
  APCI59_MINUS_PRESET_PULSE_DRIVE	         = $21;
  APCI59_PLUS_CONTINUOUS_DRIVE		         = $22;
  APCI59_MINUS_CONTINUOUS_DRIVE		         = $23;
  APCI59_PLUS_SIGNAL_SEARCH1_DRIVE	       = $24;
  APCI59_MINUS_SIGNAL_SEARCH1_DRIVE	       = $25;
  APCI59_PLUS_SIGNAL_SEARCH2_DRIVE	       = $26;
  APCI59_MINUS_SIGNAL_SEARCH2_DRIVE	       = $27;
  APCI59_INTERNAL_COUNTER_WRITE		         = $28;
  APCI59_INTERNAL_COUNTER_READ		         = $29;
  APCI59_INTERNAL_COMPARATE_DATA_WRITE	   = $2a;
  APCI59_INTERNAL_COMPARATE_DATA_READ	     = $2b;
  APCI59_EXTERNAL_COUNTER_WRITE		         = $2c;
  APCI59_EXTERNAL_COUNTER_READ		         = $2d;
  APCI59_EXTERNAL_COMPARATE_DATA_WRITE     = $2e;
  APCI59_EXTERNAL_COMPARATE_DATA_READ      = $2f;
  APCI59_INTERNAL_PRE_SCALE_DATA_WRITE     = $30;
  APCI59_INTERNAL_PRE_SCALE_DATA_READ	     = $31;
  APCI59_EXTERNAL_PRE_SCALE_DATA_WRITE	   = $32;
  APCI59_EXTERNAL_PRE_SCALE_DATA_READ	     = $33;
  APCI59_CLEAR_SIGNAL_SELECT		           = $34;
  APCI59_ONE_TIME_CLEAR_REQUEST            = $35;
  APCI59_FULL_TIME_CLEAR_REQUEST	         = $36;
  APCI59_CLEAR_REQUEST_RESET		           = $37;
  APCI59_REVERSE_COUNT_MODE_SET		         = $38;
  APCI59_REVERSE_COUNT_MODE_RESET	         = $39;
  APCI59_NO_OPERATION			                 = $3a;
  APCI59_STRAIGHT_ACCELERATE_MODE_SET	     = $84;
  APCI59_US_STRAIGHT_ACCELERATE_MODE_SET   = $85;
  APCI59_S_CURVE_ACCELERATE_MODE_SET	     = $86;
  APCI59_US_S_CURVE_ACCELERATE_MODE_SET	   = $87;
  APCI59_SW1_DATA_WRITE			               = $88;
  APCI59_SW1_DATA_READ			               = $89;
  APCI59_SW2_DATA_WRITE			               = $8a;
  APCI59_SW2_DATA_READ			               = $8b;
  APCI59_SLOW_DOWN_LIMIT_ENABLE_MODE_SET   = $8c;
  APCI59_SLOW_DOWN_LIMIT_ENABLE_MODE_RESET = $8d;
  APCI59_EMERGENCY_LIMIT_ENABLE_MODE_SET   = $8e;
  APCI59_EMERGENCY_LIMIT_ENABLE_MODE_RESET = $8f;
  APCI59_INITIAL_CLEAR			               = $90;

  // Misc
  APCI59_SLOT_AUTO											=$FFFF;
  APCI59_MAX_SLOTS											=16;
  APCI59_ERR_WRAPDLL										=DWord(-1);

  // Resource information
  APCI59_MAX_MEM												=9;
  APCI59_MAX_IO													=20;
  APCI59_MAX_IRQ												=7;
  APCI59_MAX_DMA												=7;

type TAPCI59RESOURCE = record
  dwNumMemWindows:                               DWord;  // س޳(gp)
  dwMemBase:      array [1 .. APCI59_MAX_MEM] of DWord;  // س޳ްڽ(gp)
  dwMemLength:    array [1 .. APCI59_MAX_MEM] of DWord;  // س޳(gp)
  dwMemAttrib:    array [1 .. APCI59_MAX_MEM] of DWord;  // س޳(gp)
  dwNumIOPorts:                                  DWord;  // I/O߰Đ
  dwIOPortBase:   array [1 .. APCI59_MAX_IO]  of DWord;  // I/O߰ްڽ
  dwIOPortLength: array [1 .. APCI59_MAX_IO]  of DWord;  // I/O߰Ē
  dwNumIRQs:                                     DWord;  // IRQ(gp)
  dwIRQRegisters: array [1 .. APCI59_MAX_IRQ] of DWord;  // IRQؽ(gp)
  dwIRQAttrib:    array [1 .. APCI59_MAX_IRQ] of DWord;  // IRQؽ(gp)
  dwNumDMAs:                                     DWord;  // DMAِ(gp)
  dwDMALst:       array [1 .. APCI59_MAX_DMA] of DWord;  // DMAؽ(gp)
  dwDMAAttrib:    array [1 .. APCI59_MAX_DMA] of DWord;  // DMAّؽ(gp)
  dwReserved1:    array [1 .. 3]              of DWord;  // \(gp)
end;

PAPCI59R = ^TAPCI59RESOURCE;

//DLL [h
function Apci59wDllOpen:Boolean;
//DLL A[h
function Apci59wDllClose:Boolean;
//o[Wԍ擾
function Apci59wGetVersion(var pdwDllVer:DWord; var pdwDrvVer:DWord):Boolean;
//foCX̎gp錾
function Apci59wCreate(var pwLogSlot:Word):Boolean;
//foCX̊J
function Apci59wClose(wLogSlot:Word):Boolean;
//\[X擾
function Apci59wGetResource(wLogSlot:Word;pres:PAPCI59R):Boolean;
//ǂݍݎs
function Apci59wInPort(wLogSlot:Word;wAxis:Word;wPort:Word;var pbData:Byte):Boolean;
//ݎs
function Apci59wOutPort(wLogSlot:Word;wAxis:Word;wPort:Word;bData:Byte):Boolean;
//G[R[h擾
function Apci59wGetLastError(wLogSlot:Word):DWord;
//hCuXe[^X擾
function Apci59wGetDriveStatus(wLogSlot:Word;wAxis:Word;var pbStatus:Byte):Boolean;
//GhXe[^X擾
function Apci59wGetEndStatus(wLogSlot:Word;wAxis:Word;var pbStatus:Byte):Boolean;
//JjJVOi擾
function Apci59wGetMechanicalSignal(wLogSlot:Word;wAxis:Word;var pbSignal:Byte):Boolean;
//jo[TVOi擾
function Apci59wGetUniversalSignal(wLogSlot:Word;wAxis:Word;var pbSignal:Byte):Boolean;
//[hP
function Apci59wMode1Write(wLogSlot:Word;wAxis:Word;bMode:Byte):Boolean;
//[hQ
function Apci59wMode2Write(wLogSlot:Word;wAxis:Word;bMode:Byte):Boolean;
//jo[TVOi
function Apci59wUniversalSignalWrite(wLogSlot:Word;wAxis:Word;bSignal:Byte):Boolean;
//QoCgf[^ǂݍ
function Apci59wDataHalfRead(wLogSlot:Word;wAxis:Word;bCmd:Byte;var pwData:Word):Boolean;
//SoCgf[^ǂݍ
function Apci59wDataFullRead(wLogSlot:Word;wAxis:Word;bCmd:Byte;var pdwData:DWord):Boolean;
//R}h
function Apci59wCommandWrite(wLogSlot:Word;wAxis:Word;bCmd:Byte):Boolean;
//QoCgf[^
function Apci59wDataHalfWrite(wLogSlot:Word;wAxis:Word;bCmd:Byte;wData:Word):Boolean;
//SoCgf[^
function Apci59wDataFullWrite(wLogSlot:Word;wAxis:Word;bCmd:Byte;dwData:DWord):Boolean;
//armXCb`̒l擾
function Apci59wGetSwitchValue(wLogSlot:Word;var pdwSwitchValue:DWord):Boolean;

implementation

type
  TApci59GetVersion           = function(var pdwDllVer:DWord; var pdwDrvVer:DWord):Boolean;stdcall;
  TApci59Create               = function(var pwLogSlot:Word):Boolean;stdcall;
  TApci59Close                = function(wLogSlot:Word):Boolean;stdcall;
  TApci59GetResource          = function(wLogSlot:Word;pres:PAPCI59R):Boolean;stdcall;
  TApci59InPort               = function(wLogSlot:Word;wAxis:Word;wPort:Word;var pbData:Byte):Boolean;stdcall;
  TApci59OutPort              = function(wLogSlot:Word;wAxis:Word;wPort:Word;bData:Byte):Boolean;stdcall;
  TApci59GetLastError         = function(wLogSlot:Word):Word;stdcall;
  TApci59GetDriveStatus       = function(wLogSlot:Word;wAxis:Word;var pbStatus:Byte):Boolean;stdcall;
  TApci59GetEndStatus         = function(wLogSlot:Word;wAxis:Word;var pbStatus:Byte):Boolean;stdcall;
  TApci59GetMechanicalSignal  = function(wLogSlot:Word;wAxis:Word;var pbSignal:Byte):Boolean;stdcall;
  TApci59GetUniversalSignal   = function(wLogSlot:Word;wAxis:Word;var pbSignal:Byte):Boolean;stdcall;
  TApci59Mode1Write           = function(wLogSlot:Word;wAxis:Word;bMode:Byte):Boolean;stdcall;
  TApci59Mode2Write           = function(wLogSlot:Word;wAxis:Word;bMode:Byte):Boolean;stdcall;
  TApci59UniversalSignalWrite = function(wLogSlot:Word;wAxis:Word;bSignal:Byte):Boolean;stdcall;
  TApci59DataHalfRead         = function(wLogSlot:Word;wAxis:Word;bCmd:Byte;var pwData:Word):Boolean;stdcall;
  TApci59DataFullRead         = function(wLogSlot:Word;wAxis:Word;bCmd:Byte;var pdwData:DWord):Boolean;stdcall;
  TApci59CommandWrite         = function(wLogSlot:Word;wAxis:Word;bCmd:Byte):Boolean;stdcall;
  TApci59DataHalfWrite        = function(wLogSlot:Word;wAxis:Word;bCmd:Byte;wData:Word):Boolean;stdcall;
  TApci59DataFullWrite        = function(wLogSlot:Word;wAxis:Word;bCmd:Byte;dwData:DWord):Boolean;stdcall;
  TApci59GetSwitchValue       = function(wLogSlot:Word;var pdwSwitchValue:DWord):Boolean;stdcall;

function Apci59wGetDllExportFunc:Boolean;forward;

{$J+}
const
  hDLL: THandle = 0;
{$J-}

// DLLGNX|[g֐AhX̊i[ϐ
var
  pApci59GetVersion:           TApci59GetVersion;
  pApci59Create:               TApci59Create;
  pApci59Close:                TApci59Close;
  pApci59GetResource:          TApci59GetResource;
  pApci59InPort:               TApci59InPort;
  pApci59OutPort:              TApci59OutPort;
  pApci59GetLastError:         TApci59GetLastError;
  pApci59GetDriveStatus:       TApci59GetDriveStatus;
  pApci59GetEndStatus:         TApci59GetEndStatus;
  pApci59GetMechanicalSignal:  TApci59GetMechanicalSignal;
  pApci59GetUniversalSignal:   TApci59GetUniversalSignal;
  pApci59Mode1Write:           TApci59Mode1Write;
  pApci59Mode2Write:           TApci59Mode2Write;
  pApci59UniversalSignalWrite: TApci59UniversalSignalWrite;
  pApci59DataHalfRead:         TApci59DataHalfRead;
  pApci59DataFullRead:         TApci59DataFullRead;
  pApci59CommandWrite:         TApci59CommandWrite;
  pApci59DataHalfWrite:        TApci59DataHalfWrite;
  pApci59DataFullWrite:        TApci59DataFullWrite;
  pApci59GetSwitchValue:       TApci59GetSwitchValue;
//===================================================================
//       Apci59.dll [h
//       
// ߂l     True
//           s False
//===================================================================
function Apci59wDllOpen: Boolean;
begin
  Result := False;
  if hDLL <> 0 then Exit;
  hDLL := LoadLibrary( APCI59_DLL_NAME );
  if hDLL = 0 then Exit;
  if Apci59wGetDllExportFunc = False then begin
    Apci59wDllClose;    // DLL GNX|[g֐擾ɎŝŁADLL N[Y
    Exit;
  end;
  Result := True;
end;
//===================================================================
//       Apci59.dllA[h
//       
// ߂l     True
//           s False
//===================================================================
function Apci59wDllClose: Boolean;
begin
  Result := True;
  if hDLL = 0 then Exit;
  if FreeLibrary( hDLL ) = True then hDLL := 0
  else Result := False;
end;
//===================================================================
//       o[Wԍ擾
//       pdwDllVer  DLLo[Wԍi[
//           pdwDrvVer  DRVo[Wԍi[
// ߂l     True
//           s False
//===================================================================
function Apci59wGetVersion( var pdwDllVer:DWord; var pdwDrvVer:DWord ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59GetVersion( pdwDllVer, pdwDrvVer );
end;
//===================================================================
//       foCX̎gp錾
//       pwLogSlot  gpfoCXi[
// ߂l     True
//           s False
//===================================================================
function Apci59wCreate( var pwLogSlot:Word ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59Create( pwLogSlot );
end;
//===================================================================
//       foCX̊J
//       wLogSlot  gpfoCX
// ߂l     True
//           s False
//===================================================================
function Apci59wClose( wLogSlot:Word ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59Close( wLogSlot );
end;
//===================================================================
//       wfoCX̃\[X擾
//       wLogSlot  foCX
//           pres      \[Xi[\
// ߂l     True
//           s False
//===================================================================
function Apci59wGetResource( wLogSlot:Word; pres:PAPCI59R ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59GetResource( wLogSlot, pres );
end;
//===================================================================
//       wfoCXɑ΂ǂݍݎs
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           wPort     |[gԍiO`Vj
//           pbData    ̓f[^i[
// ߂l     True
//           s False
//===================================================================
function Apci59wInPort( wLogSlot:Word; wAxis:Word; wPort:Word; var pbData:Byte ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59InPort( wLogSlot, wAxis, wPort, pbData );
end;
//===================================================================
//       wfoCXɑ΂ݎs
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           wPort     |[gԍiO`Vj
//           bData     o̓f[^
// ߂l     True
//           s False
//===================================================================
function Apci59wOutPort( wLogSlot:Word; wAxis:Word; wPort:Word; bData:Byte ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59OutPort( wLogSlot, wAxis, wPort, bData );
end;
//===================================================================
//       G[R[h擾
//       wLogSlot  foCX
// ߂l     True
//           s False
//===================================================================
function Apci59wGetLastError( wLogSlot:Word ): DWord;
begin
  Result := APCI59_ERR_WRAPDLL;
  if hDLL = 0 then Exit;
  Result := pApci59GetLastError( wLogSlot );
end;
//===================================================================
//       hCuXe[^X擾
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           pbStatus  Xe[^Xi[
// ߂l     True
//           s False
//===================================================================
function Apci59wGetDriveStatus( wLogSlot:Word; wAxis:Word; var pbStatus:Byte ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59GetDriveStatus( wLogSlot, wAxis, pbStatus );
end;
//===================================================================
//       GhXe[^X擾
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           pbStatus  Xe[^Xi[
// ߂l     True
//           s False
//===================================================================
function Apci59wGetEndStatus( wLogSlot:Word; wAxis:Word; var pbStatus:Byte ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59GetEndStatus( wLogSlot, wAxis, pbStatus );
end;
//===================================================================
//       JjJVOi擾
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           pbSignal  VOii[
// ߂l     True
//           s False
//===================================================================
function Apci59wGetMechanicalSignal( wLogSlot:Word; wAxis:Word; var pbSignal:Byte ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59GetMechanicalSignal( wLogSlot, wAxis, pbSignal );
end;
//===================================================================
//       jo[TVOi擾
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           pbSignal  VOii[
// ߂l     True
//           s False
//===================================================================
function Apci59wGetUniversalSignal( wLogSlot:Word; wAxis:Word; var pbSignal:Byte ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59GetUniversalSignal( wLogSlot, wAxis, pbSignal );
end;
//===================================================================
//       [hP
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           bMode     [hl
// ߂l     True
//           s False
//===================================================================
function Apci59wMode1Write( wLogSlot:Word; wAxis:Word; bMode:Byte ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59Mode1Write( wLogSlot, wAxis, bMode );
end;
//===================================================================
//       [hQ
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           bMode     [hl
// ߂l     True
//           s False
//===================================================================
function Apci59wMode2Write( wLogSlot:Word; wAxis:Word; bMode:Byte ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59Mode2Write( wLogSlot, wAxis, bMode );
end;
//===================================================================
//       jo[TVOi
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           bSignal   VOil
// ߂l     True
//           s False
//===================================================================
function Apci59wUniversalSignalWrite( wLogSlot:Word; wAxis:Word; bSignal:Byte ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59UniversalSignalWrite( wLogSlot, wAxis, bSignal );
end;
//===================================================================
//       QoCgf[^ǂݍ
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           bCmd      R}h
//           pwData    f[^i[
// ߂l     True
//           s False
//===================================================================
function Apci59wDataHalfRead( wLogSlot:Word; wAxis:Word; bCmd:Byte; var pwData:Word ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59DataHalfRead( wLogSlot, wAxis, bCmd, pwData );
end;
//===================================================================
//       SoCgf[^ǂݍ
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           bCmd      R}h
//           pdwData   f[^i[
// ߂l     True
//           s False
//===================================================================
function Apci59wDataFullRead( wLogSlot:Word; wAxis:Word; bCmd:Byte; var pdwData:DWord ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59DataFullRead( wLogSlot, wAxis, bCmd, pdwData );
end;
//===================================================================
//       R}h
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           bCmd      R}h
// ߂l     True
//           s False
//===================================================================
function Apci59wCommandWrite( wLogSlot:Word; wAxis:Word; bCmd:Byte ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59CommandWrite( wLogSlot, wAxis, bCmd );
end;
//===================================================================
//       QoCgf[^
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           bCmd      R}h
//           wData     f[^
// ߂l     True
//           s False
//===================================================================
function Apci59wDataHalfWrite( wLogSlot:Word; wAxis:Word; bCmd:Byte; wData:Word ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59DataHalfWrite( wLogSlot, wAxis, bCmd, wData );
end;
//===================================================================
//       SoCgf[^
//       wLogSlot  foCX
//           wAxis     Ώې䎲
//           bCmd      R}h
//           dwData    f[^
// ߂l     True
//           s False
//===================================================================
function Apci59wDataFullWrite( wLogSlot:Word; wAxis:Word; bCmd:Byte; dwData:DWord ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59DataFullWrite( wLogSlot, wAxis, bCmd, dwData );
end;
//===================================================================
//       SoCgf[^
//       wLogSlot        foCX
//           pdwSwitchValue  XCb`̒li[̈ւ̃|C^
// ߂l     True
//           s False
//===================================================================
function Apci59wGetSwitchValue( wLogSlot:Word; var pdwSwitchValue:DWord ): Boolean;
begin
  Result := False;
  if hDLL = 0 then Exit;
  Result := pApci59GetSwitchValue( wLogSlot, pdwSwitchValue );
end;
//-------------------------------------------------------------------
//       DLLGNX|[g֐AhX̎擾
//       
// ߂l     True
//           s False
//-------------------------------------------------------------------
function Apci59wGetDllExportFunc: Boolean;
begin
  Result := False;

  pApci59GetVersion              := GetProcAddress( hDLL, 'Apci59GetVersion' );
  if @pApci59GetVersion           = nil then Exit;
  pApci59Create                  := GetProcAddress( hDLL, 'Apci59Create' );
  if @pApci59Create               = nil then Exit;
  pApci59Close                   := GetProcAddress( hDLL, 'Apci59Close' );
  if @pApci59Close                = nil then Exit;
  pApci59GetResource             := GetProcAddress( hDLL, 'Apci59GetResource' );
  if @pApci59GetResource          = nil then Exit;
  pApci59InPort                  := GetProcAddress( hDLL, 'Apci59InPort' );
  if @pApci59InPort               = nil then Exit;
  pApci59OutPort                 := GetProcAddress( hDLL, 'Apci59OutPort' );
  if @pApci59OutPort              = nil then Exit;
  pApci59GetLastError            := GetProcAddress( hDLL, 'Apci59GetLastError' );
  if @pApci59GetLastError         = nil then Exit;
  pApci59GetDriveStatus          := GetProcAddress( hDLL, 'Apci59GetDriveStatus' );
  if @pApci59GetDriveStatus       = nil then Exit;
  pApci59GetEndStatus            := GetProcAddress( hDLL, 'Apci59GetEndStatus' );
  if @pApci59GetEndStatus         = nil then Exit;
  pApci59GetMechanicalSignal     := GetProcAddress( hDLL, 'Apci59GetMechanicalSignal' );
  if @pApci59GetMechanicalSignal  = nil then Exit;
  pApci59GetUniversalSignal      := GetProcAddress( hDLL, 'Apci59GetUniversalSignal' );
  if @pApci59GetUniversalSignal   = nil then Exit;
  pApci59Mode1Write              := GetProcAddress( hDLL, 'Apci59Mode1Write' );
  if @pApci59Mode1Write           = nil then Exit;
  pApci59Mode2Write              := GetProcAddress( hDLL, 'Apci59Mode2Write' );
  if @pApci59Mode2Write           = nil then Exit;
  pApci59UniversalSignalWrite    := GetProcAddress( hDLL, 'Apci59UniversalSignalWrite' );
  if @pApci59UniversalSignalWrite = nil then Exit;
  pApci59DataHalfRead            := GetProcAddress( hDLL, 'Apci59DataHalfRead' );
  if @pApci59DataHalfRead         = nil then Exit;
  pApci59DataFullRead            := GetProcAddress( hDLL, 'Apci59DataFullRead' );
  if @pApci59DataFullRead         = nil then Exit;
  pApci59CommandWrite            := GetProcAddress( hDLL, 'Apci59CommandWrite' );
  if @pApci59CommandWrite         = nil then Exit;
  pApci59DataHalfWrite           := GetProcAddress( hDLL, 'Apci59DataHalfWrite' );
  if @pApci59DataHalfWrite        = nil then Exit;
  pApci59DataFullWrite           := GetProcAddress( hDLL, 'Apci59DataFullWrite' );
  if @pApci59DataFullWrite        = nil then Exit;
  pApci59GetSwitchValue          := GetProcAddress( hDLL, 'Apci59GetSwitchValue' );
  if @pApci59GetSwitchValue       = nil then Exit;

  Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

