'****************************************************************************
'*  apci59w.vb
'*
'*  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'****************************************************************************
Option Strict Off
Option Explicit On 

Imports System
Imports System.Runtime.InteropServices

Public Class Apci59w

    Private mErrWradll As Integer = SUCCESS   ' bp[֐G[

    '-----------------------------------------------------------------
    ' Error code
    '-----------------------------------------------------------------
    Public Const SUCCESS As Integer = 0                 ' ُȂiIj
    Public Const ERR_SYSTEM As Integer = 1              ' VXeG[
    Public Const ERR_NO_DEVICE As Integer = 2           ' gp\ȃfoCX܂
    Public Const ERR_IN_USE As Integer = 3              ' w̃foCX͎gpł
    Public Const ERR_INVALID_SLOT As Integer = 4        ' Ș_Xbgł
    Public Const ERR_RESOURCE As Integer = 5            ' \[XG[
    Public Const ERR_INVALID_PORT As Integer = 6        ' sȃ|[gv
    Public Const ERR_INVALID_ARGUMENT As Integer = 7    ' sȈv܂
    Public Const ERR_INVALID_AXIS As Integer = 50       ' Ȑ䎲v
    Public Const ERR_WRAPDLL As Integer = -1            ' bp[֐G[
    '-----------------------------------------------------------------
    ' Axis
    '-----------------------------------------------------------------
    Public Const AXIS_1 As Short = 0
    Public Const AXIS_2 As Short = 1
    Public Const AXIS_3 As Short = 2
    Public Const AXIS_4 As Short = 3
    '-----------------------------------------------------------------
    ' command
    '-----------------------------------------------------------------
    Public Const RANGE_DATA_WRITE As Byte = &H0
    Public Const RANGE_DATA_READ As Byte = &H1
    Public Const START_STOP_SPEED_DATA_WRITE As Byte = &H2
    Public Const START_STOP_SPEED_DATA_READ As Byte = &H3
    Public Const OBJECT_SPEED_DATA_WRITE As Byte = &H4
    Public Const OBJECT_SPEED_DATA_READ As Byte = &H5
    Public Const RATE1_DATA_WRITE As Byte = &H6
    Public Const RATE1_DATA_READ As Byte = &H7
    Public Const RATE2_DATA_WRITE As Byte = &H8
    Public Const RATE2_DATA_READ As Byte = &H9
    Public Const RATE3_DATA_WRITE As Byte = &HA
    Public Const RATE3_DATA_READ As Byte = &HB
    Public Const RATE_CHANGE_POINT_1_2_WRITE As Byte = &HC
    Public Const RATE_CHANGE_POINT_1_2_READ As Byte = &HD
    Public Const RATE_CHANGE_POINT_2_3_WRITE As Byte = &HE
    Public Const RATE_CHANGE_POINT_2_3_READ As Byte = &HF
    Public Const SLOW_DOWN_REAR_PULSE_WRITE As Byte = &H10
    Public Const SLOW_DOWN_REAR_PULSE_READ As Byte = &H11
    Public Const NOW_SPEED_DATA_READ As Byte = &H12
    Public Const DRIVE_PULSE_COUNTER_READ As Byte = &H13
    Public Const PRESET_PULSE_DATA_OVERRIDE As Byte = &H14
    Public Const PRESET_PULSE_DATA_READ As Byte = &H15
    Public Const DEVIATION_DATA_READ As Byte = &H16
    Public Const INPOSITION_WAIT_MODE1_SET As Byte = &H17
    Public Const INPOSITION_WAIT_MODE2_SET As Byte = &H18
    Public Const INPOSITION_WAIT_MODE_RESET As Byte = &H19
    Public Const ALARM_STOP_ENABLE_MODE_SET As Byte = &H1A
    Public Const ALARM_STOP_ENABLE_MODE_RESET As Byte = &H1B
    Public Const INTERRUPT_OUT_ENABLE_MODE_SET As Byte = &H1C
    Public Const INTERRUPT_OUT_ENABLE_MODE_RESET As Byte = &H1D
    Public Const SLOW_DOWN_STOP As Byte = &H1E
    Public Const EMERGENCY_STOP As Byte = &H1F
    Public Const PLUS_PRESET_PULSE_DRIVE As Byte = &H20
    Public Const MINUS_PRESET_PULSE_DRIVE As Byte = &H21
    Public Const PLUS_CONTINUOUS_DRIVE As Byte = &H22
    Public Const MINUS_CONTINUOUS_DRIVE As Byte = &H23
    Public Const PLUS_SIGNAL_SEARCH1_DRIVE As Byte = &H24
    Public Const MINUS_SIGNAL_SEARCH1_DRIVE As Byte = &H25
    Public Const PLUS_SIGNAL_SEARCH2_DRIVE As Byte = &H26
    Public Const MINUS_SIGNAL_SEARCH2_DRIVE As Byte = &H27
    Public Const INTERNAL_COUNTER_WRITE As Byte = &H28
    Public Const INTERNAL_COUNTER_READ As Byte = &H29
    Public Const INTERNAL_COMPARATE_DATA_WRITE As Byte = &H2A
    Public Const INTERNAL_COMPARATE_DATA_READ As Byte = &H2B
    Public Const EXTERNAL_COUNTER_WRITE As Byte = &H2C
    Public Const EXTERNAL_COUNTER_READ As Byte = &H2D
    Public Const EXTERNAL_COMPARATE_DATA_WRITE As Byte = &H2E
    Public Const EXTERNAL_COMPARATE_DATA_READ As Byte = &H2F
    Public Const INTERNAL_PRE_SCALE_DATA_WRITE As Byte = &H30
    Public Const INTERNAL_PRE_SCALE_DATA_READ As Byte = &H31
    Public Const EXTERNAL_PRE_SCALE_DATA_WRITE As Byte = &H32
    Public Const EXTERNAL_PRE_SCALE_DATA_READ As Byte = &H33
    Public Const CLEAR_SIGNAL_SELECT As Byte = &H34
    Public Const ONE_TIME_CLEAR_REQUEST As Byte = &H35
    Public Const FULL_TIME_CLEAR_REQUEST As Byte = &H36
    Public Const CLEAR_REQUEST_RESET As Byte = &H37
    Public Const REVERSE_COUNT_MODE_SET As Byte = &H38
    Public Const REVERSE_COUNT_MODE_RESET As Byte = &H39
    Public Const NO_OPERATION As Byte = &H3A
    Public Const STRAIGHT_ACCELERATE_MODE_SET As Byte = &H84
    Public Const US_STRAIGHT_ACCELERATE_MODE_SET As Byte = &H85
    Public Const S_CURVE_ACCELERATE_MODE_SET As Byte = &H86
    Public Const US_S_CURVE_ACCELERATE_MODE_SET As Byte = &H87
    Public Const SW1_DATA_WRITE As Byte = &H88
    Public Const SW1_DATA_READ As Byte = &H89
    Public Const SW2_DATA_WRITE As Byte = &H8A
    Public Const SW2_DATA_READ As Byte = &H8B
    Public Const SLOW_DOWN_LIMIT_ENABLE_MODE_SET As Byte = &H8C
    Public Const SLOW_DOWN_LIMIT_ENABLE_MODE_RESET As Byte = &H8D
    Public Const EMERGENCY_LIMIT_ENABLE_MODE_SET As Byte = &H8E
    Public Const EMERGENCY_LIMIT_ENABLE_MODE_RESET As Byte = &H8F
    Public Const INITIAL_CLEAR = &H90
    '-----------------------------------------------------------------
    ' Misc
    '-----------------------------------------------------------------
    Public Const SLOT_AUTO As Short = &HFFFFS
    Public Const MAX_SLOTS As Integer = 16
    '-----------------------------------------------------------------
    ' Resource information
    '-----------------------------------------------------------------
    Public Const MIN_NUM As Integer = 0
    Public Const MAX_MEM As Integer = 9 - 1
    Public Const MAX_IO As Integer = 20 - 1
    Public Const MAX_IRQ As Integer = 7 - 1
    Public Const MAX_DMA As Integer = 7 - 1
    Public Const MAX_RSV As Integer = 3 - 1

    Structure Resource
        Dim dwNumMemWindows As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemBase() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemLength() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemAttrib() As Integer
        Dim dwNumIOPorts As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortBase() As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortLength() As Integer
        Dim dwNumIRQs As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQRegisters() As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQAttrib() As Integer
        Dim dwNumDMAs As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMALst() As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMAAttrib() As Integer
        <VBFixedArray(MAX_RSV), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_RSV + 1)> Dim dwReserved1() As Integer
    End Structure

    '-----------------------------------------------------------------
    ' API Functions
    '-----------------------------------------------------------------
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59GetVersion(ByRef pdwDllVer As Integer, ByRef pdwDrvVer As Integer) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59Create(ByRef pwLogSlot As Short) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59Close(ByVal wLogSlot As Short) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59GetResource(ByVal wLogSlot As Short, ByRef pres As Resource) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59InPort(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal wPort As Short, ByRef pbData As Byte) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59OutPort(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal wPort As Short, ByVal bData As Byte) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59GetLastError(ByVal wLogSlot As Short) As Short
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59GetDriveStatus(ByVal wLogSlot As Short, ByVal wAxis As Short, ByRef pbStatus As Byte) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59GetEndStatus(ByVal wLogSlot As Short, ByVal wAxis As Short, ByRef pbStatus As Byte) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59GetMechanicalSignal(ByVal wLogSlot As Short, ByVal wAxis As Short, ByRef pbSignal As Byte) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59GetUniversalSignal(ByVal wLogSlot As Short, ByVal wAxis As Short, ByRef pbSignal As Byte) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59Mode1Write(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bMode As Byte) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59Mode2Write(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bMode As Byte) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59UniversalSignalWrite(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bSignal As Byte) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59DataHalfRead(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bCmd As Byte, ByRef pwData As Short) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59DataFullRead(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bCmd As Byte, ByRef pdwData As Integer) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59CommandWrite(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bCmd As Byte) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59DataHalfWrite(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bCmd As Byte, ByVal pwData As Short) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59DataFullWrite(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bCmd As Byte, ByVal pdwData As Integer) As Boolean
    End Function
    <DllImport("apci59.dll")> _
    Public Shared Function Apci59GetSwitchValue(ByVal wLogSlot As Short, ByRef pdwSwitchValue As Integer) As Boolean
    End Function

    '===================================================================
    '    o[Wԍ擾
    '    pdwDllVer  DLLo[Wԍi[
    '        pdwDrvVer  DRVo[Wԍi[
    ' ߂l  True
    '        s False
    '===================================================================
    Function GetVersion(ByRef pdwDllVer As Integer, ByRef pdwDrvVer As Integer) As Boolean
        Try
            GetVersion = Apci59GetVersion(pdwDllVer, pdwDrvVer)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetVersion = False
        End Try
    End Function
    '===================================================================
    '    foCX̎gp錾
    '    pwLogSlot gpfoCXi[
    ' ߂l  True
    '        s False
    '===================================================================
    Function Create(ByRef pwLogSlot As Short) As Boolean
        Try
            Create = Apci59Create(pwLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Create = False
        End Try
    End Function
    '===================================================================
    '    foCX̊J
    '    wLogSlot   gpfoCX
    ' ߂l  True
    '        s False
    '===================================================================
    Function Close(ByVal wLogSlot As Short) As Integer
        Try
            Close = Apci59Close(wLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Close = False
        End Try
    End Function
    '===================================================================
    '    wfoCX̃\[X擾
    '    wLogSlot   foCX
    '        pres       \[Xi[\
    ' ߂l  True
    '        s False
    '===================================================================
    Function GetResource(ByVal wLogSlot As Short, ByRef pres As Resource) As Boolean
        Try
            GetResource = Apci59GetResource(wLogSlot, pres)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetResource = False
        End Try
    End Function
    '===================================================================
    '    wfoCXɑ΂ǂݍݎs
    '    wLogSlot       foCX
    '        wAxis          Ώې䎲
    '        wPort          |[gԍiO`Vj
    '        pbData         ̓f[^i[
    ' ߂l  True
    '        s False
    '===================================================================
    Function InPort(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal wPort As Short, ByRef pbData As Byte) As Boolean
        Try
            InPort = Apci59InPort(wLogSlot, wAxis, wPort, pbData)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            InPort = False
        End Try
    End Function
    '===================================================================
    '    wfoCXɑ΂ݎs
    '    wLogSlot       foCX
    '        wAxis          Ώې䎲
    '        wPort          |[gԍiO`Vj
    '        bData          o̓f[^
    ' ߂l  True
    '        s False
    '===================================================================
    Function OutPort(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal wPort As Short, ByVal bData As Byte) As Boolean
        Try
            OutPort = Apci59OutPort(wLogSlot, wAxis, wPort, bData)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            OutPort = False
        End Try
    End Function
    '===================================================================
    '    G[R[h擾
    '    wLogSlot       foCX
    ' ߂l  True
    '        s False
    '===================================================================
    Function GetLastError(ByVal wLogSlot As Short) As Integer
        Try
            If mErrWradll = ERR_WRAPDLL Then    ' bp[֐G[Ȃ
                mErrWradll = SUCCESS            ' NA
                GetLastError = ERR_WRAPDLL
            Else
                GetLastError = Apci59GetLastError(wLogSlot)
            End If
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            GetLastError = ERR_WRAPDLL
            mErrWradll = SUCCESS            ' NA
        End Try
    End Function
    '===================================================================
    '    hCuXe[^X擾
    '    wLogSlot   foCX
    '        wAxis      Ώې䎲
    '        pbStatus   Xe[^Xi[
    ' ߂l  True
    '        s False
    '===================================================================
    Function GetDriveStatus(ByVal wLogSlot As Short, ByVal wAxis As Short, ByRef pbStatus As Byte) As Boolean
        Try
            GetDriveStatus = Apci59GetDriveStatus(wLogSlot, wAxis, pbStatus)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetDriveStatus = False
        End Try
    End Function
    '===================================================================
    '    GhXe[^X擾
    '    wLogSlot   foCX
    '        wAxis      Ώې䎲
    '        pbStatus   Xe[^Xi[
    ' ߂l  True
    '        s False
    '===================================================================
    Function GetEndStatus(ByVal wLogSlot As Short, ByVal wAxis As Short, ByRef pbStatus As Byte) As Boolean
        Try
            GetEndStatus = Apci59GetEndStatus(wLogSlot, wAxis, pbStatus)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetEndStatus = False
        End Try
    End Function
    '===================================================================
    '    JjJVOi擾
    '    wLogSlot   foCX
    '        wAxis      Ώې䎲
    '        pbSignal   VOii[
    ' ߂l  True
    '        s False
    '===================================================================
    Function GetMechanicalSignal(ByVal wLogSlot As Short, ByVal wAxis As Short, ByRef pbSignal As Byte) As Boolean
        Try
            GetMechanicalSignal = Apci59GetMechanicalSignal(wLogSlot, wAxis, pbSignal)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetMechanicalSignal = False
        End Try
    End Function
    '===================================================================
    '    jo[TVOi擾
    '    wLogSlot   foCX
    '        wAxis      Ώې䎲
    '        pbSignal   VOii[
    ' ߂l  True
    '        s False
    '===================================================================
    Function GetUniversalSignal(ByVal wLogSlot As Short, ByVal wAxis As Short, ByRef pbSignal As Byte) As Boolean
        Try
            GetUniversalSignal = Apci59GetUniversalSignal(wLogSlot, wAxis, pbSignal)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetUniversalSignal = False
        End Try
    End Function
    '===================================================================
    '    [hP
    '    wLogSlot   foCX
    '        wAxis      Ώې䎲
    '        bMode      [hl
    ' ߂l  True
    '        s False
    '===================================================================
    Function Mode1Write(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bMode As Byte) As Boolean
        Try
            Mode1Write = Apci59Mode1Write(wLogSlot, wAxis, bMode)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Mode1Write = False
        End Try
    End Function
    '===================================================================
    '    [hQ
    '    wLogSlot   foCX
    '        wAxis      Ώې䎲
    '        bMode      [hl
    ' ߂l  True
    '        s False
    '===================================================================
    Function Mode2Write(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bMode As Byte) As Boolean
        Try
            Mode2Write = Apci59Mode2Write(wLogSlot, wAxis, bMode)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Mode2Write = False
        End Try
    End Function
    '===================================================================
    '    jo[TVOi
    '    wLogSlot   foCX
    '        wAxis      Ώې䎲
    '        bSignal    VOil
    ' ߂l  True
    '        s False
    '===================================================================
    Function UniversalSignalWrite(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bSignal As Byte) As Boolean
        Try
            UniversalSignalWrite = Apci59UniversalSignalWrite(wLogSlot, wAxis, bSignal)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            UniversalSignalWrite = False
        End Try
    End Function
    '===================================================================
    '    QoCgf[^ǂݍ
    '    wLogSlot   foCX
    '        wAxis      Ώې䎲
    '        bCmd       R}h
    '        pwData     f[^i[
    ' ߂l  True
    '        s False
    '===================================================================
    Function DataHalfRead(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bCmd As Byte, ByRef pwData As Short) As Boolean
        Try
            DataHalfRead = Apci59DataHalfRead(wLogSlot, wAxis, bCmd, pwData)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            DataHalfRead = False
        End Try
    End Function
    '===================================================================
    '    SoCgf[^ǂݍ
    '    wLogSlot   foCX
    '        wAxis      Ώې䎲
    '        bCmd       R}h
    '        pdwData    f[^i[
    ' ߂l  True
    '        s False
    '===================================================================
    Function DataFullRead(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bCmd As Byte, ByRef pdwData As Integer) As Boolean
        Try
            DataFullRead = Apci59DataFullRead(wLogSlot, wAxis, bCmd, pdwData)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            DataFullRead = False
        End Try
    End Function
    '===================================================================
    '    R}h
    '    wLogSlot   foCX
    '        wAxis      Ώې䎲
    '        bCmd       R}h
    ' ߂l  True
    '        s False
    '===================================================================
    Function CommandWrite(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bCmd As Byte) As Boolean
        Try
            CommandWrite = Apci59CommandWrite(wLogSlot, wAxis, bCmd)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            CommandWrite = False
        End Try
    End Function
    '===================================================================
    '    QoCgf[^
    '    wLogSlot   foCX
    '        wAxis      Ώې䎲
    '        bCmd       R}h
    '        wData     f[^
    ' ߂l  True
    '        s False
    '===================================================================
    Function DataHalfWrite(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bCmd As Byte, ByVal pwData As Short) As Boolean
        Try
            DataHalfWrite = Apci59DataHalfWrite(wLogSlot, wAxis, bCmd, pwData)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            DataHalfWrite = False
        End Try
    End Function
    '===================================================================
    '    SoCgf[^
    '    wLogSlot   foCX
    '        wAxis      Ώې䎲
    '        bCmd       R}h
    '        dwData     f[^
    ' ߂l  True
    '        s False
    '===================================================================
    Function DataFullWrite(ByVal wLogSlot As Short, ByVal wAxis As Short, ByVal bCmd As Byte, ByVal pdwData As Integer) As Boolean
        Try
            DataFullWrite = Apci59DataFullWrite(wLogSlot, wAxis, bCmd, pdwData)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            DataFullWrite = False
        End Try
    End Function
    '===================================================================
    '    armXCb`̒l擾
    '    wLogSlot       foCX
    '        pdwSwitchValue XCb`̒li[̈ւ̃|C^
    ' ߂l  True
    '        s False
    '===================================================================
    Function GetSwitchValue(ByVal wLogSlot As Short, ByRef pdwSwitchValue As Integer) As Boolean
        Try
            GetSwitchValue = Apci59GetSwitchValue(wLogSlot, pdwSwitchValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-M59 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetSwitchValue = False
        End Try
    End Function

End Class
