//===================================================================
// Apci59s.h
//-------------------------------------------------------------------
// aPCI-M59
// Copyright (C) ADTEK SYSTEM SCIENCE Co.,Ltd.
//
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
//===================================================================
#pragma once

#include <windows.h>
#include "Apci59w.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

namespace SampleM59
{
	/// <summary> 
	/// Apci59s ̊Tv
	///
	/// x : ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ 
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB 
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public __gc class Apci59s : public System::Windows::Forms::Form
	{
	public: 
		Apci59s(void)
		{
			InitializeComponent();
		}
        
	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
        
	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container* components;

		static Apci59w* M59w;

		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			// 
			// Apci59s
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 12);
			this->ClientSize = System::Drawing::Size(292, 266);
			this->Name = S"Apci59s";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = S"aPCI-M59 Sample";
			this->Load += new System::EventHandler(this, Apci59s_Load);

		}		
		private: System::Void Apci59s_Load(System::Object *  sender, System::EventArgs *  e)
		{
			String*				szBuf;
			int					dwDllVer, dwDrvVer;
			short				wLogSlot, wAxis;
			Apci59w::Resource*	ri;
			Byte				b;
			int					dwCount;
			int					dwSwVal;
			int					i;

			M59w = new Apci59w;
			ri   = new Apci59w::Resource;
			ri->dwMemBase		= new Int32[Apci59w::MAX_MEM];
			ri->dwMemLength		= new Int32[Apci59w::MAX_MEM];
			ri->dwMemAttrib		= new Int32[Apci59w::MAX_MEM];
			ri->dwIOPortBase	= new Int32[Apci59w::MAX_IO];
			ri->dwIOPortLength	= new Int32[Apci59w::MAX_IO];
			ri->dwIRQRegisters	= new Int32[Apci59w::MAX_IRQ];
			ri->dwIRQAttrib		= new Int32[Apci59w::MAX_IRQ];
			ri->dwDMALst		= new Int32[Apci59w::MAX_DMA];
			ri->dwDMAAttrib		= new Int32[Apci59w::MAX_DMA];
			ri->dwReserved1		= new Int32[Apci59w::MAX_RSV];

			// 
			ri->dwNumMemWindows = 0;
			for (i=0; i<Apci59w::MAX_MEM; i++) {
				ri->dwMemBase[i]   = 0;
				ri->dwMemLength[i] = 0;
				ri->dwMemAttrib[i] = 0;
			}
			ri->dwNumIOPorts = 0;
			for (i=0; i<Apci59w::MAX_IO; i++) {
				ri->dwIOPortBase[i]   = 0;
				ri->dwIOPortLength[i] = 0;
			}
			ri->dwNumIRQs = 0;
			for (i=0; i<Apci59w::MAX_IRQ; i++) {
				ri->dwIRQRegisters[i] = 0;
				ri->dwIRQAttrib[i]    = 0;
			}
			ri->dwNumDMAs = 0;
			for (i=0; i<Apci59w::MAX_DMA; i++) {
				ri->dwDMALst[i]    = 0;
				ri->dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Apci59w::MAX_RSV; i++)
				ri->dwReserved1[i] = 0;

			//---------------------------------------------------------------
			// o[W̕\
			//---------------------------------------------------------------
			if (false == M59w->GetVersion(&dwDllVer,&dwDrvVer)) {
				ErrorMessage(Apci59w::SLOT_AUTO);
				return;
			}
			szBuf = String::Concat(S"Version\n",
									String::Format(S"DLL: 0x{0}\n", dwDllVer.ToString("x8")),
									String::Format(S"DRV: 0x{0}",   dwDrvVer.ToString("x8")));
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// foCX̎gp錾
			//---------------------------------------------------------------
			wLogSlot = Apci59w::SLOT_AUTO;		// 󂫃foCXw
			if (false == M59w->Create(&wLogSlot) ) {
				ErrorMessage(Apci59w::SLOT_AUTO);
				return;
			}
			szBuf = String::Concat(S"Created\n\n",
									String::Format(S"LogSlot: {0}", wLogSlot.ToString("d")));
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// \[X\
			//---------------------------------------------------------------
			if (false == M59w->GetResource(wLogSlot,ri)) {
				ErrorMessage(wLogSlot);
				return;
			}
			
			szBuf = String::Concat(S"Resource\n",
									String::Format(S"IO Base Address  \t: {0}h - {1}h\n",
													ri->dwIOPortBase[0].ToString("x4"),
													(ri->dwIOPortBase[0] + ri->dwIOPortLength[0] - 1).ToString("x4")));
			ResultMessage(szBuf);
			//---------------------------------------------------------------
			// armXCb`̒l\
			//---------------------------------------------------------------
			if (false == M59w->GetSwitchValue(wLogSlot,&dwSwVal)) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Format(S"BSN : {0}h", dwSwVal.ToString("x"));
			ResultMessage(szBuf);
			//---------------------------------------------------------------
			// PI
			//---------------------------------------------------------------
			wAxis = Apci59w::AXIS_1;
			//---------------------------------------------------------------
			// 䎲̏
			//---------------------------------------------------------------
			if (false == InitAxis(wLogSlot,wAxis)) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Format(S"䎲 {0} ܂", wAxis.ToString());
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// { 10000 pXo
			//---------------------------------------------------------------
			if ( false == M59w->DataFullWrite(wLogSlot, wAxis, 
												Apci59w::PLUS_PRESET_PULSE_DRIVE, 10000 ) ) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat(S"{ 10000pXo͂Ă܂");
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// hCuXe[^X擾
			//---------------------------------------------------------------
			b = 0;
			if ( false == M59w->GetDriveStatus( wLogSlot, wAxis, &b ) ) {
				ErrorMessage(wLogSlot);
				return;
			}
			//---------------------------------------------------------------
			// rW[tOĂihCuȂj~
			//---------------------------------------------------------------
			if ( b & 0x01 ) {
				if ( false == M59w->CommandWrite( wLogSlot, wAxis, Apci59w::SLOW_DOWN_STOP ) ){
					ErrorMessage(wLogSlot);
					return;
				}
				szBuf = String::Concat(S"~܂");
				ResultMessage( szBuf );
			}
			//---------------------------------------------------------------
			// GhXe[^X擾
			//---------------------------------------------------------------
			if ( false == M59w->GetEndStatus( wLogSlot, wAxis, &b ) ) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Format(S"GhXe[^X: {0}h", b.ToString("x"));
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// JE^[\
			//---------------------------------------------------------------
			dwCount = 0;
			if ( false == M59w->DataFullRead(wLogSlot, wAxis, 
											Apci59w::INTERNAL_COUNTER_READ, &dwCount ) ) {
				ErrorMessage(wLogSlot);
				return;
			}
			//---------------------------------------------------------------
			// g
			//---------------------------------------------------------------
			if ( dwCount & 0x08000000 )
				dwCount |= 0xF0000000;
			szBuf = String::Format(S"JE^[: {0}", dwCount.ToString());
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// JjJVOi\
			//---------------------------------------------------------------
			if ( false == M59w->GetMechanicalSignal( wLogSlot, wAxis, &b ) ) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Format(S"JjJVOi: {0}h", b.ToString("x"));
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// jo[TVOi\
			//---------------------------------------------------------------
			if ( false == M59w->GetUniversalSignal( wLogSlot, wAxis, &b ) ) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Format(S"jo[TVOi: {0}h", b.ToString("x"));
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// foCX
			//---------------------------------------------------------------
			if ( false == M59w->Close(wLogSlot)){
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat(S"Close\n",
									String::Format(S"LogSlot {0}",
													wLogSlot.ToString()));
			ResultMessage( szBuf );
			this->Close();
		}

		//-------------------------------------------------------------------
		// 䎲̏
		//-------------------------------------------------------------------
		//   		wLogSlot	foCXԍ
		//				wAxis		䎲
		//             	AXIS_1 ` AXIS_4 w肵܂
		//-------------------------------------------------------------------
		private: bool InitAxis(short wLogSlot, short wAxis)
		{
			//---------------------------------------------------------------
			// MODE1 SET
			//
			// Jn|Cgo				
			// pXo͕						QpX
			// DIR   o͒[q 						CWpX  ANeBu Hi
			// PULSE o͒[q						CCWpX ANeBu Hi
			//---------------------------------------------------------------
			if ( false == M59w->Mode1Write(wLogSlot,wAxis,0x40)) return false;
			//---------------------------------------------------------------
			// MODE2 SET
			//
			// EXTERNAL COUNTER ͎dl			QMS{
			// DEND ͐MANeBux		Low
			// DERR ͐MANeBux		Low
			// -SLM ͐MANeBux		Low
			// +SLM ͐MANeBux		Low
			// -ELM ͐MANeBux		Low
			// +ELM ͐MANeBux		Low
			//---------------------------------------------------------------
			if ( false == M59w->Mode2Write(wLogSlot,wAxis,0xFF)) return false;
			//---------------------------------------------------------------
			// [hݒ
			//
			// INPOSITION WAIT MODE RESET
			// ALARM STOP ENABLE MODE SET
			// INTERRUPT OUT ENABLE MODE RESET
			//---------------------------------------------------------------
			if ( false == M59w->CommandWrite(wLogSlot,wAxis,
											Apci59w::INPOSITION_WAIT_MODE_RESET))
				return false;
			if ( false == M59w->CommandWrite(wLogSlot,wAxis,
											Apci59w::ALARM_STOP_ENABLE_MODE_SET))
				return false;
			if ( false == M59w->CommandWrite(wLogSlot,wAxis,
											Apci59w::INTERRUPT_OUT_ENABLE_MODE_RESET))
				return false;
			//---------------------------------------------------------------
			// f[^ݒ
			//
			// RANGE DATA				50		o͎gݒP 	50050=10PPS
			// START/STOP SPEED DATA	100		Jn~g 		100~10PPS=1000PPS
			// OBJECT SPEED DATA		4000	ړIg 			4000~10PPS=40000PPS
			// RATE-1 DATA              1024	ԐݒP 	1024(2.048~10^6)=0.5mSec
			//									 			(4000-100)~0.5mSec = 1.95Sec
			// RATE-2 DATA        				ftHgl 8191(1FFFh)
			// RATE-3 DATA						ftHgl 8191(1FFFh)
			// RATE CHANGE POINT 1-2			ftHgl 8191(1FFFh)
			// RATE CHANGE POINT 2-3			ftHgl 8191(1FFFh)
			//
			// ̐ݒɂ RATE-1 DATA ɂ钼ƂȂ܂
			//---------------------------------------------------------------
			if ( false == M59w->DataHalfWrite(wLogSlot,wAxis,
												Apci59w::RANGE_DATA_WRITE,50))
				return false;
			if ( false == M59w->DataHalfWrite(wLogSlot,wAxis,
												Apci59w::START_STOP_SPEED_DATA_WRITE,100))
				return false;
			if ( false == M59w->DataFullWrite(wLogSlot,wAxis,
												Apci59w::OBJECT_SPEED_DATA_WRITE,4000))
				return false;
			if ( false == M59w->DataFullWrite(wLogSlot,wAxis,
												Apci59w::RATE1_DATA_WRITE,1024))
				return false;
			//---------------------------------------------------------------
			// AhXݒ
			//
			// INTERNAL COUNTER y EXTERNAL COUNTER  0h ݂܂
			//---------------------------------------------------------------
			if ( false == M59w->DataFullWrite(wLogSlot,wAxis,
												Apci59w::INTERNAL_COUNTER_WRITE,0))
				return false;
			if ( false == M59w->DataFullWrite(wLogSlot,wAxis,
												Apci59w::EXTERNAL_COUNTER_WRITE,0))
				return false;

			return TRUE;
		}

		//-------------------------------------------------------------------
		// ʂ\
		//-------------------------------------------------------------------
		private: void ResultMessage(String* pszbuf)
		{
			MessageBox::Show(pszbuf, this->Text, 
								MessageBoxButtons::OK, MessageBoxIcon::Information);
		}
		
		//-------------------------------------------------------------------
		// G[bZ[W\
		//-------------------------------------------------------------------
		private: void ErrorMessage(WORD wLogSlot)
		{
			int dwRes = M59w->GetLastError(wLogSlot);
			String* szbuf;

			switch (dwRes) {
				case Apci59w::ERR_SYSTEM:
				case Apci59w::ERR_WRAPDLL:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					szbuf = String::Concat(S"System error\n\n",
											String::Format(S"Error code: {0}", 
															dwRes.ToString("x8")));
					break;
				default:
					szbuf = String::Concat(S"aPCI-M59 error\n\n",
											String::Format(S"Error code: {0}", 
															dwRes.ToString("x8")));
					break;
			}
			MessageBox::Show(szbuf, S"aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}

	};
}
