//===================================================================
// Apci59s.h
//-------------------------------------------------------------------
// aPCI-M59
// Copyright (C) ADTEK SYSTEM SCIENCE Co.,Ltd.
//
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
//===================================================================
#pragma once

#include <windows.h>
#include "Apci59w.h"

namespace SampleM59 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Form1 ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

		static Apci59w *M59w;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->SuspendLayout();
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(292, 266);
			this->Name = L"Form1";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"aPCI-M59 Sample";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->ResumeLayout(false);

		}
#pragma endregion
		private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) {
			String^				szBuf;
			int					dwDllVer, dwDrvVer;
			short				wLogSlot, wAxis;
			Apci59w::Resource*	ri;
			Byte				b;
			int					dwCount;
			int					dwSwVal;
			int					i;

			M59w = new Apci59w;
			ri   = new Apci59w::Resource;

			// 
			ri->dwNumMemWindows = 0;
			for (i=0; i<Apci59w::MAX_MEM; i++) {
				ri->dwMemBase[i]   = 0;
				ri->dwMemLength[i] = 0;
				ri->dwMemAttrib[i] = 0;
			}
			ri->dwNumIOPorts = 0;
			for (i=0; i<Apci59w::MAX_IO; i++) {
				ri->dwIOPortBase[i]   = 0;
				ri->dwIOPortLength[i] = 0;
			}
			ri->dwNumIRQs = 0;
			for (i=0; i<Apci59w::MAX_IRQ; i++) {
				ri->dwIRQRegisters[i] = 0;
				ri->dwIRQAttrib[i]    = 0;
			}
			ri->dwNumDMAs = 0;
			for (i=0; i<Apci59w::MAX_DMA; i++) {
				ri->dwDMALst[i]    = 0;
				ri->dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Apci59w::MAX_RSV; i++)
				ri->dwReserved1[i] = 0;

			//---------------------------------------------------------------
			// o[W̕\
			//---------------------------------------------------------------
			if (false == M59w->GetVersion(&dwDllVer,&dwDrvVer)) {
				ErrorMessage(Apci59w::SLOT_AUTO);
				return;
			}
			szBuf = String::Concat("Version\n",
									String::Format("DLL: 0x{0:x8}\n", dwDllVer),
									String::Format("DRV: 0x{0:x8}",   dwDrvVer));
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// foCX̎gp錾
			//---------------------------------------------------------------
			wLogSlot = Apci59w::SLOT_AUTO;		// 󂫃foCXw
			if (false == M59w->Create(&wLogSlot) ) {
				ErrorMessage(Apci59w::SLOT_AUTO);
				return;
			}
			szBuf = String::Concat("Created\n\n",
									String::Format("LogSlot: {0}", wLogSlot));
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// \[X\
			//---------------------------------------------------------------
			if (false == M59w->GetResource(wLogSlot,ri)) {
				ErrorMessage(wLogSlot);
				return;
			}
			
			szBuf = String::Concat("Resource\n",
									String::Format("IO Base Address  \t: {0:x4}h - {1:x4}h\n",
													ri->dwIOPortBase[0],
													ri->dwIOPortBase[0] + ri->dwIOPortLength[0] - 1));
			ResultMessage(szBuf);
			//---------------------------------------------------------------
			// armXCb`̒l\
			//---------------------------------------------------------------
			if (false == M59w->GetSwitchValue(wLogSlot,&dwSwVal)) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Format("BSN : {0:x}h", dwSwVal);
			ResultMessage(szBuf);
			//---------------------------------------------------------------
			// PI
			//---------------------------------------------------------------
			wAxis = Apci59w::AXIS_1;
			//---------------------------------------------------------------
			// 䎲̏
			//---------------------------------------------------------------
			if (false == InitAxis(wLogSlot,wAxis)) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Format("䎲 {0} ܂", wAxis);
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// { 10000 pXo
			//---------------------------------------------------------------
			if ( false == M59w->DataFullWrite(wLogSlot, wAxis, 
												Apci59w::PLUS_PRESET_PULSE_DRIVE, 10000 ) ) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat("{ 10000pXo͂Ă܂");
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// hCuXe[^X擾
			//---------------------------------------------------------------
			if ( false == M59w->GetDriveStatus( wLogSlot, wAxis, &b ) ) {
				ErrorMessage(wLogSlot);
				return;
			}
			//---------------------------------------------------------------
			// rW[tOĂihCuȂj~
			//---------------------------------------------------------------
			if ( b & 0x01 ) {
				if ( false == M59w->CommandWrite( wLogSlot, wAxis, Apci59w::SLOW_DOWN_STOP ) ){
					ErrorMessage(wLogSlot);
					return;
				}
				szBuf = String::Concat("~܂");
				ResultMessage( szBuf );
			}
			//---------------------------------------------------------------
			// GhXe[^X擾
			//---------------------------------------------------------------
			if ( false == M59w->GetEndStatus( wLogSlot, wAxis, &b ) ) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Format("GhXe[^X: {0:x}h", b);
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// JE^[\
			//---------------------------------------------------------------
			dwCount = 0;
			if ( false == M59w->DataFullRead(wLogSlot, wAxis, 
											Apci59w::INTERNAL_COUNTER_READ, &dwCount ) ) {
				ErrorMessage(wLogSlot);
				return;
			}
			//---------------------------------------------------------------
			// g
			//---------------------------------------------------------------
			if ( dwCount & 0x08000000 )
				dwCount |= 0xF0000000;
			szBuf = String::Format("JE^[: {0}", dwCount);
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// JjJVOi\
			//---------------------------------------------------------------
			if ( false == M59w->GetMechanicalSignal( wLogSlot, wAxis, &b ) ) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Format("JjJVOi: {0:x}h", b);
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// jo[TVOi\
			//---------------------------------------------------------------
			if ( false == M59w->GetUniversalSignal( wLogSlot, wAxis, &b ) ) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Format("jo[TVOi: {0:x}h", b);
			ResultMessage( szBuf );
			//---------------------------------------------------------------
			// foCX
			//---------------------------------------------------------------
			if ( false == M59w->Close(wLogSlot)){
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat("Close\n",
									String::Format("LogSlot {0}", wLogSlot));
			ResultMessage( szBuf );
			this->Close();
		}

		//-------------------------------------------------------------------
		// 䎲̏
		//-------------------------------------------------------------------
		//   		wLogSlot	foCXԍ
		//				wAxis		䎲
		//             	AXIS_1 ` AXIS_4 w肵܂
		//-------------------------------------------------------------------
		private: bool InitAxis(short wLogSlot, short wAxis)
		{
			//---------------------------------------------------------------
			// MODE1 SET
			//
			// Jn|Cgo				
			// pXo͕						QpX
			// DIR   o͒[q 						CWpX  ANeBu Hi
			// PULSE o͒[q						CCWpX ANeBu Hi
			//---------------------------------------------------------------
			if ( false == M59w->Mode1Write(wLogSlot,wAxis,0x40)) return false;
			//---------------------------------------------------------------
			// MODE2 SET
			//
			// EXTERNAL COUNTER ͎dl			QMS{
			// DEND ͐MANeBux		Low
			// DERR ͐MANeBux		Low
			// -SLM ͐MANeBux		Low
			// +SLM ͐MANeBux		Low
			// -ELM ͐MANeBux		Low
			// +ELM ͐MANeBux		Low
			//---------------------------------------------------------------
			if ( false == M59w->Mode2Write(wLogSlot,wAxis,0xFF)) return false;
			//---------------------------------------------------------------
			// [hݒ
			//
			// INPOSITION WAIT MODE RESET
			// ALARM STOP ENABLE MODE SET
			// INTERRUPT OUT ENABLE MODE RESET
			//---------------------------------------------------------------
			if ( false == M59w->CommandWrite(wLogSlot,wAxis,
											Apci59w::INPOSITION_WAIT_MODE_RESET))
				return false;
			if ( false == M59w->CommandWrite(wLogSlot,wAxis,
											Apci59w::ALARM_STOP_ENABLE_MODE_SET))
				return false;
			if ( false == M59w->CommandWrite(wLogSlot,wAxis,
											Apci59w::INTERRUPT_OUT_ENABLE_MODE_RESET))
				return false;
			//---------------------------------------------------------------
			// f[^ݒ
			//
			// RANGE DATA				50		o͎gݒP 	50050=10PPS
			// START/STOP SPEED DATA	100		Jn~g 		100~10PPS=1000PPS
			// OBJECT SPEED DATA		4000	ړIg 			4000~10PPS=40000PPS
			// RATE-1 DATA              1024	ԐݒP 	1024(2.048~10^6)=0.5mSec
			//									 			(4000-100)~0.5mSec = 1.95Sec
			// RATE-2 DATA        				ftHgl 8191(1FFFh)
			// RATE-3 DATA						ftHgl 8191(1FFFh)
			// RATE CHANGE POINT 1-2			ftHgl 8191(1FFFh)
			// RATE CHANGE POINT 2-3			ftHgl 8191(1FFFh)
			//
			// ̐ݒɂ RATE-1 DATA ɂ钼ƂȂ܂
			//---------------------------------------------------------------
			if ( false == M59w->DataHalfWrite(wLogSlot,wAxis,
												Apci59w::RANGE_DATA_WRITE,50))
				return false;
			if ( false == M59w->DataHalfWrite(wLogSlot,wAxis,
												Apci59w::START_STOP_SPEED_DATA_WRITE,100))
				return false;
			if ( false == M59w->DataFullWrite(wLogSlot,wAxis,
												Apci59w::OBJECT_SPEED_DATA_WRITE,4000))
				return false;
			if ( false == M59w->DataFullWrite(wLogSlot,wAxis,
												Apci59w::RATE1_DATA_WRITE,1024))
				return false;
			//---------------------------------------------------------------
			// AhXݒ
			//
			// INTERNAL COUNTER y EXTERNAL COUNTER  0h ݂܂
			//---------------------------------------------------------------
			if ( false == M59w->DataFullWrite(wLogSlot,wAxis,
												Apci59w::INTERNAL_COUNTER_WRITE,0))
				return false;
			if ( false == M59w->DataFullWrite(wLogSlot,wAxis,
												Apci59w::EXTERNAL_COUNTER_WRITE,0))
				return false;

			return TRUE;
		}

		//-------------------------------------------------------------------
		// ʂ\
		//-------------------------------------------------------------------
		private: void ResultMessage(String^ pszbuf)
		{
			MessageBox::Show(pszbuf, this->Text, 
								MessageBoxButtons::OK, MessageBoxIcon::Information);
		}
		
		//-------------------------------------------------------------------
		// G[bZ[W\
		//-------------------------------------------------------------------
		private: void ErrorMessage(WORD wLogSlot)
		{
			int dwRes = M59w->GetLastError(wLogSlot);
			String^ szbuf;

			switch (dwRes) {
				case Apci59w::ERR_SYSTEM:
				case Apci59w::ERR_WRAPDLL:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					szbuf = String::Concat("System error\n\n",
											String::Format("Error code: {0:x8}", dwRes));
					break;
				default:
					szbuf = String::Concat("aPCI-M59 error\n\n",
											String::Format("Error code: {0:x8}", dwRes));
					break;
			}
			MessageBox::Show(szbuf, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}


	};
}

