/*============================================================================
//	apci59w.h
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Runtime::InteropServices;

static int mErrWradll;	// bp[֐G[

public class Apci59w
{
public:
	// error code
	static const int	SUCCESS								= 0;	// ُȂiIj
	static const int	ERR_SYSTEM							= 1;	// VXeG[
																	// Windows  GetLastError()
																	// R[Ă
	static const int	ERR_NO_DEVICE						= 2;	// gp\ȃfoCX܂
	static const int	ERR_IN_USE							= 3;	// w̃foCX͎gpł
	static const int	ERR_INVALID_SLOT					= 4;	// Ș_Xbgł
	static const int	ERR_RESOURCE						= 5;	// \[XG[
	static const int	ERR_INVALID_PORT					= 6;	// sȃ|[gv
	static const int	ERR_INVALID_ARGUMENT				= 7;	// sȈv܂
	static const int	INVALID_AXIS						= 50;	// Ȑ䎲v
	static const int	ERR_WRAPDLL							= -1;	// bp[֐G[

	// Misc..
	static const short	SLOT_AUTO							= -1;
	static const int	MAX_SLOTS							= 16;

	// Axis
	static const short	AXIS_1								= 0;
	static const short	AXIS_2								= 1;
	static const short	AXIS_3								= 2;
	static const short	AXIS_4								= 3;

	// I/O Map
	static const short	PORT_DATA1							= 0x00;
	static const short	PORT_DATA2							= 0x01;
	static const short	PORT_DATA3							= 0x02;
	static const short	PORT_DATA4							= 0x03;
	static const short	PORT_COMMAND						= 0x04;
	static const short	PORT_MODE1							= 0x05;
	static const short	PORT_MODE2							= 0x06;
	static const short	PORT_UNIVERSAL_SIGNAL				= 0x07;
	static const short	PORT_DRIVE_STATUS					= 0x04;
	static const short	PORT_END_STATUS						= 0x05;
	static const short	PORT_MECHANICAL_SIGNAL				= 0x06;

	// Commands
	static const Byte	RANGE_DATA_WRITE					= 0x00;
	static const Byte	RANGE_DATA_READ						= 0x01;
	static const Byte	START_STOP_SPEED_DATA_WRITE			= 0x02;
	static const Byte	START_STOP_SPEED_DATA_READ			= 0x03;
	static const Byte	OBJECT_SPEED_DATA_WRITE				= 0x04;
	static const Byte	OBJECT_SPEED_DATA_READ				= 0x05;
	static const Byte	RATE1_DATA_WRITE					= 0x06;
	static const Byte	RATE1_DATA_READ						= 0x07;
	static const Byte	RATE2_DATA_WRITE					= 0x08;
	static const Byte	RATE2_DATA_READ						= 0x09;
	static const Byte	RATE3_DATA_WRITE					= 0x0a;
	static const Byte	RATE3_DATA_READ						= 0x0b;
	static const Byte	RATE_CHANGE_POINT_1_2_WRITE			= 0x0c;
	static const Byte	RATE_CHANGE_POINT_1_2_READ			= 0x0d;
	static const Byte	RATE_CHANGE_POINT_2_3_WRITE			= 0x0e;
	static const Byte	RATE_CHANGE_POINT_2_3_READ			= 0x0f;
	static const Byte	SLOW_DOWN_REAR_PULSE_WRITE			= 0x10;
	static const Byte	SLOW_DOWN_REAR_PULSE_READ			= 0x11;
	static const Byte	NOW_SPEED_DATA_READ					= 0x12;
	static const Byte	DRIVE_PULSE_COUNTER_READ			= 0x13;
	static const Byte	PRESET_PULSE_DATA_OVERRIDE			= 0x14;
	static const Byte	PRESET_PULSE_DATA_READ				= 0x15;
	static const Byte	DEVIATION_DATA_READ					= 0x16;
	static const Byte	INPOSITION_WAIT_MODE1_SET			= 0x17;
	static const Byte	INPOSITION_WAIT_MODE2_SET			= 0x18;
	static const Byte	INPOSITION_WAIT_MODE_RESET			= 0x19;
	static const Byte	ALARM_STOP_ENABLE_MODE_SET			= 0x1a;
	static const Byte	ALARM_STOP_ENABLE_MODE_RESET		= 0x1b;
	static const Byte	INTERRUPT_OUT_ENABLE_MODE_SET		= 0x1c;
	static const Byte	INTERRUPT_OUT_ENABLE_MODE_RESET		= 0x1d;
	static const Byte	SLOW_DOWN_STOP						= 0x1e;
	static const Byte	EMERGENCY_STOP						= 0x1f;
	static const Byte	PLUS_PRESET_PULSE_DRIVE				= 0x20;
	static const Byte	MINUS_PRESET_PULSE_DRIVE			= 0x21;
	static const Byte	PLUS_CONTINUOUS_DRIVE				= 0x22;
	static const Byte	MINUS_CONTINUOUS_DRIVE				= 0x23;
	static const Byte	PLUS_SIGNAL_SEARCH1_DRIVE			= 0x24;
	static const Byte	MINUS_SIGNAL_SEARCH1_DRIVE			= 0x25;
	static const Byte	PLUS_SIGNAL_SEARCH2_DRIVE			= 0x26;
	static const Byte	MINUS_SIGNAL_SEARCH2_DRIVE			= 0x27;
	static const Byte	INTERNAL_COUNTER_WRITE				= 0x28;
	static const Byte	INTERNAL_COUNTER_READ				= 0x29;
	static const Byte	INTERNAL_COMPARATE_DATA_WRITE		= 0x2a;
	static const Byte	INTERNAL_COMPARATE_DATA_READ		= 0x2b;
	static const Byte	EXTERNAL_COUNTER_WRITE				= 0x2c;
	static const Byte	EXTERNAL_COUNTER_READ				= 0x2d;
	static const Byte	EXTERNAL_COMPARATE_DATA_WRITE		= 0x2e;
	static const Byte	EXTERNAL_COMPARATE_DATA_READ		= 0x2f;
	static const Byte	INTERNAL_PRE_SCALE_DATA_WRITE		= 0x30;
	static const Byte	INTERNAL_PRE_SCALE_DATA_READ		= 0x31;
	static const Byte	EXTERNAL_PRE_SCALE_DATA_WRITE		= 0x32;
	static const Byte	EXTERNAL_PRE_SCALE_DATA_READ		= 0x33;
	static const Byte	CLEAR_SIGNAL_SELECT					= 0x34;
	static const Byte	ONE_TIME_CLEAR_REQUEST				= 0x35;
	static const Byte	FULL_TIME_CLEAR_REQUEST				= 0x36;
	static const Byte	CLEAR_REQUEST_RESET					= 0x37;
	static const Byte	REVERSE_COUNT_MODE_SET				= 0x38;
	static const Byte	REVERSE_COUNT_MODE_RESET			= 0x39;
	static const Byte	NO_OPERATION						= 0x3a;
	static const Byte	STRAIGHT_ACCELERATE_MODE_SET		= 0x84;
	static const Byte	US_STRAIGHT_ACCELERATE_MODE_SET		= 0x85;
	static const Byte	S_CURVE_ACCELERATE_MODE_SET			= 0x86;
	static const Byte	US_S_CURVE_ACCELERATE_MODE_SET		= 0x87;
	static const Byte	SW1_DATA_WRITE						= 0x88;
	static const Byte	SW1_DATA_READ						= 0x89;
	static const Byte	SW2_DATA_WRITE						= 0x8a;
	static const Byte	SW2_DATA_READ						= 0x8b;
	static const Byte	SLOW_DOWN_LIMIT_ENABLE_MODE_SET		= 0x8c;
	static const Byte	SLOW_DOWN_LIMIT_ENABLE_MODE_RESET	= 0x8d;
	static const Byte	EMERGENCY_LIMIT_ENABLE_MODE_SET		= 0x8e;
	static const Byte	EMERGENCY_LIMIT_ENABLE_MODE_RESET	= 0x8f;
	static const Byte	INITIAL_CLEAR						= 0x90;

	// resources
	static const int	MAX_MEM					= 9;
	static const int	MAX_IO					= 20;
	static const int	MAX_IRQ					= 7;
	static const int	MAX_DMA					= 7;
	static const int	MAX_RSV					= 3;

	struct Resource {
		int	dwNumMemWindows;
		int dwMemBase[Apci59w::MAX_MEM];
		int dwMemLength[Apci59w::MAX_MEM];
		int dwMemAttrib[Apci59w::MAX_MEM];
		int	dwNumIOPorts;
		int dwIOPortBase[Apci59w::MAX_IO];
		int dwIOPortLength[Apci59w::MAX_IO];
		int dwNumIRQs;
		int dwIRQRegisters[Apci59w::MAX_IRQ];
		int dwIRQAttrib[Apci59w::MAX_IRQ];
		int dwNumDMAs;
		int dwDMALst[Apci59w::MAX_DMA];
		int dwDMAAttrib[Apci59w::MAX_DMA];
		int dwReserved1[Apci59w::MAX_RSV];
	};

	// API
	[DllImport("apci59.dll")]
	static bool Apci59GetVersion( int* pdwDllVersion, int* pdwDrvVersion);
	[DllImport("apci59.dll")]
	static bool Apci59Create( short* pwLogSlot );
	[DllImport("apci59.dll")]
	static bool Apci59Close(short wLogSlot);
	[DllImport("apci59.dll")]
	static bool Apci59GetResource(short wLogSlot, Resource* pres);
	[DllImport("apci59.dll")]
	static bool Apci59InPort( short wLogSlot, short wAxis ,short wPort, Byte* pbData );
	[DllImport("apci59.dll")]
	static bool Apci59OutPort( short wLogSlot, short wAxis ,short wPort, Byte bData );
	[DllImport("apci59.dll")]
	static bool Apci59GetDriveStatus( short wLogSlot, short wAxis, Byte* pbStatus);
	[DllImport("apci59.dll")]
	static bool Apci59GetEndStatus( short wLogSlot, short wAxis, Byte* pbStatus);
	[DllImport("apci59.dll")]
	static bool Apci59GetMechanicalSignal( short wLogSlot, short wAxis, Byte* pbSignal );
	[DllImport("apci59.dll")]
	static bool Apci59GetUniversalSignal( short wLogSlot, short wAxis, Byte* pbSignal );
	[DllImport("apci59.dll")]
	static bool Apci59Mode1Write( short wLogSlot, short wAxis, Byte bMode );
	[DllImport("apci59.dll")]
	static bool Apci59Mode2Write( short wLogSlot, short wAxis, Byte bMode );
	[DllImport("apci59.dll")]
	static bool Apci59UniversalSignalWrite( short wLogSlot, short wAxis, Byte bSignal );
	[DllImport("apci59.dll")]
	static bool Apci59DataHalfRead( short wLogSlot, short wAxis, Byte bCmd, short* pwData );
	[DllImport("apci59.dll")]
	static bool Apci59DataFullRead( short wLogSlot, short wAxis, Byte bCmd, int* pdwData );
	[DllImport("apci59.dll")]
	static bool Apci59CommandWrite( short wLogSlot, short wAxis, Byte bCmd );
	[DllImport("apci59.dll")]
	static bool Apci59DataHalfWrite( short wLogSlot, short wAxis, Byte bCmd, short wData );
	[DllImport("apci59.dll")]
	static bool Apci59DataFullWrite( short wLogSlot, short wAxis, Byte bCmd, int dwData );
	[DllImport("apci59.dll")]
	static bool Apci59GetSwitchValue( short wLogSlot, int* pdwSwitchValue );
	[DllImport("apci59.dll")]
	static int  Apci59GetLastError( short wLogSlot );

	//===================================================================
	//   		o[Wԍ擾
	//   		pdwDllVersion	DLL o[Wi[̈ւ̃|C^
	//				pdwDrvVersion	DRV o[Wi[̈ւ̃|C^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool GetVersion( int* pdwDllVersion, int* pdwDrvVersion)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59GetVersion(pdwDllVersion,pdwDrvVersion);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		foCX̎gp錾
	//   		pwLogSlot		foCXi[̈ւ̃|C^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool Create( short* pwLogSlot )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59Create(pwLogSlot);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		foCX̉
	//   		wLogSlot		foCX
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool Close(short wLogSlot)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59Close(wLogSlot);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		\[X擾
	//   		wLogSlot		foCX
	//				pres			\[Xi[̈ւ̃|C^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool GetResource(short wLogSlot, Resource* pres)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59GetResource(wLogSlot,pres);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		ǂݍݎs
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				wPort			Ώۃ|[gԍ
	//				pbData			ǂݍ񂾃f[^i[̈ւ̃|C^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool InPort( short wLogSlot, short wAxis ,short wPort, Byte* pbData )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59InPort(wLogSlot,wAxis,wPort,pbData);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		ݎs
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				wPort			Ώۃ|[gԍ
	//				bData			ޒl
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool OutPort( short wLogSlot, short wAxis ,short wPort, Byte bData )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59OutPort(wLogSlot,wAxis,wPort,bData);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		hCuXe[^X擾
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				pbStatus		i[̈ւ̃|C^	
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool GetDriveStatus( short wLogSlot, short wAxis, Byte* pbStatus)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59GetDriveStatus(wLogSlot,wAxis,pbStatus);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		GhXe[^X擾
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				pbStatus		i[̈ւ̃|C^	
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool GetEndStatus( short wLogSlot, short wAxis, Byte* pbStatus)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59GetEndStatus(wLogSlot,wAxis,pbStatus);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		JjJVOi擾
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				pbSignal		i[̈ւ̃|C^	
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool GetMechanicalSignal( short wLogSlot, short wAxis, Byte* pbSignal )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59GetMechanicalSignal(wLogSlot,wAxis,pbSignal);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		jo[TVOi擾
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				pbSignal		i[̈ւ̃|C^	
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool GetUniversalSignal( short wLogSlot, short wAxis, Byte* pbSignal )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59GetUniversalSignal(wLogSlot,wAxis,pbSignal);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		[hP
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				bMode			ރf[^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool Mode1Write( short wLogSlot, short wAxis, Byte bMode )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59Mode1Write(wLogSlot,wAxis,bMode);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		[hQ
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				bMode			ރf[^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool Mode2Write( short wLogSlot, short wAxis, Byte bMode )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59Mode2Write(wLogSlot,wAxis,bMode);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		jo[TVOi
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				bSignal			ރf[^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool UniversalSignalWrite( short wLogSlot, short wAxis, Byte bSignal )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59UniversalSignalWrite(wLogSlot,wAxis,bSignal);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		QoCgf[^ǂݍ
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				bCmd			ǂݍݎɎsR}h
	//				pwData			ǂݍ񂾃f[^i[̈ւ̃|C^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool DataHalfRead( short wLogSlot, short wAxis, Byte bCmd, short* pwData )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59DataHalfRead(wLogSlot,wAxis,bCmd,pwData);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		SoCgf[^ǂݍ
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				bCmd			ǂݍݎɎsR}h
	//				pdwData			ǂݍ񂾃f[^i[̈ւ̃|C^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool DataFullRead( short wLogSlot, short wAxis, Byte bCmd, int* pdwData )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59DataFullRead(wLogSlot,wAxis,bCmd,pdwData);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		R}h
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				bCmd			R}h
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool CommandWrite( short wLogSlot, short wAxis, Byte bCmd )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59CommandWrite(wLogSlot,wAxis,bCmd);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		QoCgf[^
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				bCmd			ݎɎsR}h
	//				wData			ރf[^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool DataHalfWrite( short wLogSlot, short wAxis, Byte bCmd, short wData )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59DataHalfWrite(wLogSlot,wAxis,bCmd,wData);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		SoCgf[^
	//   		wLogSlot		foCX
	//				wAxis			Ώې䎲
	//				bCmd			ݎɎsR}h
	//				dwData			ރf[^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool DataFullWrite( short wLogSlot, short wAxis, Byte bCmd, int dwData )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59DataFullWrite(wLogSlot,wAxis,bCmd,dwData);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		armXCb`̒lǂݍ
	//   		wLogSlot		foCX
	//				pdwSwitchValue	XCb`̒li[̈ւ̃|C^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool GetSwitchValue( short wLogSlot, int* pdwSwitchValue )
	{
		mErrWradll = SUCCESS;
		try {
			return Apci59GetSwitchValue(wLogSlot,pdwSwitchValue);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		G[R[h擾
	//   		wLogSlot		foCX
	// ߂l		G[R[h
	//===================================================================
	static int GetLastError( short wLogSlot )
	{
		try {
			if (mErrWradll == ERR_WRAPDLL) {	// bp[֐G[Ȃ
				mErrWradll = SUCCESS;			// NA
				return ERR_WRAPDLL;
			} else {
				return Apci59GetLastError(wLogSlot);
			}
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-M59 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = SUCCESS;	// bp[֐G[
			return ERR_WRAPDLL;
		}
	}

};
