Attribute VB_Name = "Sample"
'===================================================================
' Apci59s.pas
'-------------------------------------------------------------------
' aPCI-M59
' Copyright (C) ADTEK SYSTEM SCIENCE Co.,Ltd.
'
' ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
'===================================================================
Option Explicit                         'SĂ̕ϐ𖾎Iɐ錾

Private Const szApci59 = "aPCI-M59"
Private Declare Function GetLastError Lib "kernel32" () As Long
'===================================================================
' Jn
'===================================================================
Sub Main()

    Dim strbuf As String
    Dim dwDllVer As Long, dwDrvVer As LoadResConstants
    Dim wLogSlot As Integer
    Dim wAxis As Integer
    Dim ri As APCI59RESOURCE
    Dim b As Byte
    Dim dwCount As Long
    Dim dwSWVal As Long

    '---------------------------------------------------------------
    ' Apci59.Dll J
    '---------------------------------------------------------------
    If False = Apci59wDllOpen() Then
        ErrorMessage (APCI59_SLOT_AUTO)
        Exit Sub
    End If
    '---------------------------------------------------------------
    ' o[W\
    '---------------------------------------------------------------
    If False = Apci59wGetVersion(dwDllVer, dwDrvVer) Then
        ErrorMessage (APCI59_SLOT_AUTO)
        Exit Sub
    End If
    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Driver Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' foCX̎gp錾
    '---------------------------------------------------------------
    wLogSlot = APCI59_SLOT_AUTO     '󂫃foCXw
    If False = Apci59wCreate(wLogSlot) Then
        ErrorMessage (APCI59_SLOT_AUTO)
        Exit Sub
    End If
    strbuf = "aPCI-M59 Created" + Chr(10) + Chr(10) + _
             "LogSlot: " + Str(wLogSlot)
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' \[X\
    '---------------------------------------------------------------
    If False = Apci59wGetResource(wLogSlot, ri) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "Board Name: " + szApci59 + Chr(10) + _
             "IO Base Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1)
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' armXCb`̒l\
    '---------------------------------------------------------------
    If False = Apci59wGetSwitchValue(wLogSlot, dwSWVal) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "Board Name: " + szApci59 + Chr(10) + _
        "BSN: &H" + Hex(dwSWVal)
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' Pw
    '---------------------------------------------------------------
    wAxis = APCI59_AXIS_1
    '---------------------------------------------------------------
    ' 䎲
    '---------------------------------------------------------------
    If False = Apci59_InitAxis(wLogSlot, wAxis) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "aPCI-M59" + Chr(10) + _
             "䎲܂"
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' { 1000pXo
    '---------------------------------------------------------------
    If False = Apci59wDataFullWrite( _
        wLogSlot, wAxis, APCI59_PLUS_PRESET_PULSE_DRIVE, 1000) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "aPCI-M59" + Chr(10) + _
             "{ 1000pXo͂Ă܂"
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' hCuXe[^X擾
    '---------------------------------------------------------------
    If False = Apci59wGetDriveStatus(wLogSlot, wAxis, b) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    '---------------------------------------------------------------
    ' rW[tOĂihCuȂj~
    '---------------------------------------------------------------
    If b And &H1 Then
        If False = Apci59wCommandWrite( _
            wLogSlot, wAxis, APCI59_SLOW_DOWN_STOP) Then
            ErrorMessage (wLogSlot)
            Exit Sub
        End If
        strbuf = "aPCI-M59" + Chr(10) + _
                 "~܂"
        ResultMessage (strbuf)
    End If
    '---------------------------------------------------------------
    ' GhXe[^X擾
    '---------------------------------------------------------------
    If False = Apci59wGetEndStatus(wLogSlot, wAxis, b) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "aPCI-M59" + Chr(10) + _
             "GhXe[^X " + Hex(b) + "h"
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' JE^[\
    '---------------------------------------------------------------
    If False = Apci59wDataFullRead( _
        wLogSlot, wAxis, APCI59_INTERNAL_COUNTER_READ, dwCount) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    '---------------------------------------------------------------
    ' g
    '---------------------------------------------------------------
    If dwCount And &H8000000 Then dwCount = dwCount Or &HF0000000

    strbuf = "aPCI-M59" + Chr(10) + _
             "JE^ " + CStr(dwCount)
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' JjJVOi\
    '---------------------------------------------------------------
    If False = Apci59wGetMechanicalSignal(wLogSlot, wAxis, b) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "aPCI-M59" + Chr(10) + _
             "JjJVOi " + Hex(b) + "h"
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' jo[TVOi\
    '---------------------------------------------------------------
    If False = Apci59wGetUniversalSignal(wLogSlot, wAxis, b) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "aPCI-M59" + Chr(10) + _
             "jo[TVOi " + Hex(b) + "h"
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' foCX
    '---------------------------------------------------------------
    If False = Apci59wClose(wLogSlot) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    ResultMessage ("aPCI-M59 Closed")
    '---------------------------------------------------------------
    ' Apci59.Dll 
    '---------------------------------------------------------------
    If False = Apci59wDllClose() Then
        MsgBox "DLL Unload error", vbOKOnly + vbCritical
        Exit Sub
    End If

End Sub
'===================================================================
' 䎲̏
'-------------------------------------------------------------------
'           wLogSlot    foCXԍ
'               wAxis       䎲
'                           APCI59_AXIS_1 ` APCI59_AXIS_4 w肵܂
'===================================================================
Function Apci59_InitAxis(ByVal wLogSlot As Integer, ByVal wAxis As Integer) As Integer

    Apci59_InitAxis = False
    '---------------------------------------------------------------
    ' MODE1 SET
    '
    ' Jn|Cgo              
    ' pXo͕                        QpX
    ' DIR   o͒[q                        CWpX  ANeBu Hi
    ' PULSE o͒[q                        CCWpX ANeBu Hi
    '---------------------------------------------------------------
    If False = Apci59wMode1Write(wLogSlot, wAxis, &H40) Then Exit Function
    '---------------------------------------------------------------
    ' MODE2 SET
    '
    ' EXTERNAL COUNTER ͎dl             QMS{
    ' DEND ͐MANeBux         Low
    ' DERR ͐MANeBux         Low
    ' -SLM ͐MANeBux         Low
    ' +SLM ͐MANeBux         Low
    ' -ELM ͐MANeBux         Low
    ' +ELM ͐MANeBux         Low
    '---------------------------------------------------------------
    If False = Apci59wMode2Write(wLogSlot, wAxis, &HFF) Then Exit Function
    '---------------------------------------------------------------
    ' [hݒ
    '
    ' INPOSITION WAIT MODE RESET
    ' ALARM STOP ENABLE MODE SET
    ' INTERRUPT OUT ENABLE MODE RESET
    '---------------------------------------------------------------
    If False = Apci59wCommandWrite(wLogSlot, wAxis, APCI59_INPOSITION_WAIT_MODE_RESET) Then Exit Function
    If False = Apci59wCommandWrite(wLogSlot, wAxis, APCI59_ALARM_STOP_ENABLE_MODE_SET) Then Exit Function
    If False = Apci59wCommandWrite(wLogSlot, wAxis, APCI59_INTERRUPT_OUT_ENABLE_MODE_RESET) Then Exit Function
    '---------------------------------------------------------------
    ' f[^ݒ
    '
    ' RANGE DATA                 50  o͎gݒP  50050=10PPS
    ' START/STOP SPEED DATA     100  Jn~g      100~10PPS=1000PPS
    ' OBJECT SPEED DATA        4000  ړIg          4000~10PPS=40000PPS
    ' RATE-1 DATA              1024  ԐݒP    1024(2.048~10^6)=0.5mSec
    '                                            (4000-100)~0.5mSec = 1.95Sec
    ' RATE-2 DATA                    ftHgl 8191(1FFFh)
    ' RATE-3 DATA                    ftHgl 8191(1FFFh)
    ' RATE CHANGE POINT 1-2          ftHgl 8191(1FFFh)
    ' RATE CHANGE POINT 2-3          ftHgl 8191(1FFFh)
    '
    ' ̐ݒɂ RATE-1 DATA ɂ钼ƂȂ܂
    '---------------------------------------------------------------
    If False = Apci59wDataHalfWrite(wLogSlot, wAxis, APCI59_RANGE_DATA_WRITE, 50) Then Exit Function
    If False = Apci59wDataHalfWrite(wLogSlot, wAxis, APCI59_START_STOP_SPEED_DATA_WRITE, 100) Then Exit Function
    If False = Apci59wDataFullWrite(wLogSlot, wAxis, APCI59_OBJECT_SPEED_DATA_WRITE, 4000) Then Exit Function
    If False = Apci59wDataFullWrite(wLogSlot, wAxis, APCI59_RATE1_DATA_WRITE, 1024) Then Exit Function
    '---------------------------------------------------------------
    ' AhXݒ
    '
    ' INTERNAL COUNTER y EXTERNAL COUNTER  0h ݂܂
    '---------------------------------------------------------------
    If False = Apci59wDataFullWrite(wLogSlot, wAxis, APCI59_INTERNAL_COUNTER_WRITE, 0) Then Exit Function
    If False = Apci59wDataFullWrite(wLogSlot, wAxis, APCI59_EXTERNAL_COUNTER_WRITE, 0) Then Exit Function

    Apci59_InitAxis = True

End Function
'===================================================================
' ʂ\
'===================================================================
Private Sub ResultMessage(lpszbuf As String)
    
    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub
'===================================================================
' G[bZ[W\
'===================================================================
Private Sub ErrorMessage(wLogSlot As Integer)
    
    Dim dwRes As Long
    Dim szbuf As String
    
    dwRes = Apci59wGetLastError(wLogSlot)

    Select Case dwRes
    Case APCI59_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aPCI-M59 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub

